// Generated automatically with "cito". Do not edit.

function A4rStream()
{
	this.content = null;
	this.contentLength = 0;
	this.contentOffset = 0;
	this.innerFlags = 0;
	this.outerFlags = 0;
	this.unpacked = new Array(11248);
	this.unpackedOffset = 0;
	this.outerFlags = this.innerFlags = 0;
}

A4rStream.prototype.copyBlock = function(distance, length) {
	if (distance > this.unpackedOffset)
		return false;
	do {
		if (!this.storeByte(this.unpacked[this.unpackedOffset - distance]))
			return false;
	}
	while (--length > 0);
	return true;
}

A4rStream.prototype.readByte = function() {
	if (this.contentOffset >= this.contentLength)
		return -1;
	return this.content[this.contentOffset++];
}

A4rStream.prototype.readFlag = function() {
	if ((this.innerFlags & 127) == 0) {
		if ((this.outerFlags & 127) == 0) {
			if (this.contentOffset >= this.contentLength)
				return -1;
			this.outerFlags = this.content[this.contentOffset++] << 1 | 1;
		}
		else
			this.outerFlags <<= 1;
		if ((this.outerFlags & 256) == 0)
			this.innerFlags = 1;
		else {
			if (this.contentOffset >= this.contentLength)
				return -1;
			this.innerFlags = this.content[this.contentOffset++] << 1 | 1;
		}
	}
	else
		this.innerFlags <<= 1;
	return this.innerFlags >> 8 & 1;
}

A4rStream.prototype.storeByte = function(value) {
	if (this.unpackedOffset < 0 || this.unpackedOffset >= 11248)
		return false;
	this.unpacked[this.unpackedOffset++] = value;
	return true;
}

A4rStream.prototype.unpackA4r = function() {
	Ci.clearArray(this.unpacked, 0);
	this.unpackedOffset = -1;
	for (;;) {
		var b;
		switch (this.readFlag()) {
		case -1:
			return false;
		case 0:
			b = this.readByte();
			if (b < 0)
				return false;
			if (!this.storeByte(b))
				return false;
			break;
		case 1:
			b = this.readByte();
			switch (b) {
			case -1:
				return false;
			case 0:
				if (this.contentOffset + 2 >= this.contentLength)
					return false;
				b = this.readByte();
				this.unpackedOffset = b + (this.readByte() << 8) + 128 - 19984;
				if (!this.storeByte(this.readByte()))
					return false;
				break;
			case 1:
				b = this.readByte();
				switch (b) {
				case -1:
					return false;
				case 0:
					return true;
				default:
					if (!this.copyBlock(1, b + 2))
						return false;
					break;
				}
				break;
			default:
				if (!this.copyBlock(128 - (b >> 1), 2 + (b & 1)))
					return false;
				break;
			}
			break;
		}
	}
}

function BitStream()
{
	this.bits = 0;
	this.content = null;
	this.contentLength = 0;
	this.contentOffset = 0;
	this.bits = 0;
}

BitStream.prototype.readBit = function() {
	if ((this.bits & 127) == 0) {
		if (this.contentOffset >= this.contentLength)
			return -1;
		this.bits = this.content[this.contentOffset++] << 1 | 1;
	}
	else
		this.bits <<= 1;
	return this.bits >> 8 & 1;
}

BitStream.prototype.readBits = function(count) {
	var result = 0;
	while (--count >= 0) {
		var bit = this.readBit();
		if (bit < 0)
			return -1;
		result = result << 1 | bit;
	}
	return result;
}

function BlazingPaddlesBoundingBox()
{
	this.bottom = 0;
	this.left = 0;
	this.right = 0;
	this.top = 0;
}

BlazingPaddlesBoundingBox.prototype.calculate = function(content, contentLength, index, startAddress) {
	if (index * 2 + 1 >= contentLength)
		return false;
	var contentOffset = content[index * 2] + (content[index * 2 + 1] << 8) - startAddress;
	if (contentOffset < 0)
		return false;
	this.left = this.top = this.right = this.bottom = 0;
	var x = 0;
	var y = 0;
	while (contentOffset < contentLength) {
		var control = content[contentOffset++];
		if (control == 8)
			return true;
		var len = (control >> 4) + 1;
		switch (control & 3) {
		case 0:
			x += len;
			if (this.right < x)
				this.right = x;
			break;
		case 1:
			x -= len;
			if (this.left > x)
				this.left = x;
			break;
		case 2:
			y -= len;
			if (this.top > y)
				this.top = y;
			break;
		case 3:
			y += len;
			if (this.bottom < y)
				this.bottom = y;
			break;
		}
	}
	return false;
}

function RleStream()
{
	this.repeatCount = 0;
	this.repeatValue = 0;
	this.repeatCount = 0;
}
RleStream.prototype = new BitStream();

RleStream.prototype.readByte = function() {
	if (this.contentOffset >= this.contentLength)
		return -1;
	return this.content[this.contentOffset++];
}

RleStream.prototype.readRle = function() {
	while (this.repeatCount == 0) {
		if (!this.readCommand())
			return -1;
	}
	this.repeatCount--;
	if (this.repeatValue >= 0)
		return this.repeatValue;
	return this.readValue();
}

RleStream.prototype.readValue = function() {
	return this.readByte();
}

RleStream.prototype.unpack = function(unpacked, unpackedOffset, unpackedStride, unpackedCount) {
	for (var offset = 0;;) {
		var b = this.readRle();
		if (b < 0)
			return false;
		unpacked[unpackedOffset + offset] = b;
		offset += unpackedStride;
		if (offset >= unpackedCount) {
			if (unpackedStride > 1)
				offset -= unpackedCount - 1;
			if (offset >= unpackedStride)
				return true;
		}
	}
}

function CaStream()
{
	this.defaultValue = 0;
	this.escapeByte = 0;
}
CaStream.prototype = new RleStream();

CaStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b != this.escapeByte) {
		this.repeatCount = 1;
		this.repeatValue = b;
		return true;
	}
	var c = this.readByte();
	if (c < 0)
		return false;
	if (c == this.escapeByte) {
		this.repeatCount = 1;
		this.repeatValue = c;
		return true;
	}
	b = this.readByte();
	if (b < 0)
		return false;
	switch (c) {
	case 0:
		this.repeatCount = b + 1;
		this.repeatValue = this.readByte();
		break;
	case 1:
		c = this.readByte();
		if (c < 0)
			return false;
		this.repeatCount = (b << 8) + c + 1;
		this.repeatValue = this.readByte();
		break;
	case 2:
		if (b == 0)
			this.repeatCount = 32000;
		else {
			c = this.readByte();
			if (c < 0)
				return false;
			this.repeatCount = (b << 8) + c + 1;
		}
		this.repeatValue = this.defaultValue;
		break;
	default:
		this.repeatCount = c + 1;
		this.repeatValue = b;
		break;
	}
	return true;
}

CaStream.unpackCa = function(content, contentOffset, contentLength, unpacked, unpackedOffset) {
	if (contentOffset + 4 > contentLength)
		return false;
	var rle = new CaStream();
	rle.content = content;
	rle.contentOffset = contentOffset + 4;
	rle.contentLength = contentLength;
	rle.escapeByte = content[contentOffset];
	rle.defaultValue = content[contentOffset + 1];
	var unpackedStep = content[contentOffset + 2] << 8 | content[contentOffset + 3];
	if (unpackedStep >= 32000)
		return false;
	if (unpackedStep == 0) {
		rle.repeatCount = 32000;
		rle.repeatValue = rle.defaultValue;
		unpackedStep = 1;
	}
	var isFilled = new Array(32000);
	Ci.clearArray(isFilled, 0);
	for (var offset = 0;;) {
		var b = rle.readRle();
		if (b < 0)
			return false;
		unpacked[unpackedOffset + offset] = b;
		isFilled[offset] = 1;
		offset += unpackedStep;
		if (offset >= 32000) {
			for (offset = 1; isFilled[offset] != 0; offset++)
				if (offset >= unpackedStep)
					return true;
		}
	}
}

CaStream.unpackDel = function(content, contentLength, unpacked, blocks) {
	var contentOffset = blocks << 2;
	if (contentOffset >= contentLength)
		return false;
	var unpackedOffset = 0;
	for (var block = 0; block < blocks; block++) {
		var nextContentOffset = contentOffset + FAIL.get32BigEndian(content, block << 2);
		if (!CaStream.unpackCa(content, contentOffset, nextContentOffset, unpacked, unpackedOffset))
			return false;
		contentOffset = nextContentOffset;
		unpackedOffset += 32000;
	}
	if (blocks == 2) {
		if (!CaStream.unpackCa(content, contentOffset, contentLength, unpacked, unpackedOffset))
			return false;
	}
	return true;
}

function CciStream()
{
}
CciStream.prototype = new RleStream();

CciStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		this.repeatCount = b + 1;
		this.repeatValue = -1;
	}
	else {
		this.repeatCount = b - 127;
		this.repeatValue = this.readByte();
	}
	return true;
}

CciStream.prototype.unpackGr15 = function(unpacked, unpackedOffset) {
	this.contentOffset += 4;
	this.repeatCount = 0;
	for (var offset = 0;;) {
		var b = this.readRle();
		if (b < 0)
			return false;
		unpacked[unpackedOffset + offset] = b;
		offset += 80;
		if (offset >= 7680) {
			offset -= 7679;
			if (offset >= 40)
				return true;
		}
	}
}

function FAIL()
{
	this.atari16Palette = new Array(256);
	this.atari8Palette = new Array(256);
	this.colors = 0;
	this.frames = 0;
	this.gtiaColors = new Array(16);
	this.gtiaLeftSkip = 0;
	this.height = 0;
	this.palette = new Array(256);
	this.pixels = new Array(358400);
	this.resolution = FAILResolution.XE1X1;
	this.width = 0;
	this.setAtari8Palette(null);
}

FAIL.prototype.applyAtari8Palette = function(frame) {
	var pixelsLength = this.width * this.height;
	for (var i = 0; i < pixelsLength; i++)
		this.pixels[i] = this.atari8Palette[frame[i]];
	return true;
}

FAIL.prototype.applyAtari8PaletteBlend = function(frame1, frame2) {
	var pixelsLength = this.width * this.height;
	this.frames = 2;
	for (var i = 0; i < pixelsLength; i++) {
		var rgb1 = this.atari8Palette[frame1[i]];
		var rgb2 = this.atari8Palette[frame2[i]];
		this.pixels[i] = (rgb1 & rgb2) + ((rgb1 ^ rgb2) >> 1 & 8355711);
	}
	return true;
}

FAIL.prototype.applyAtari8PaletteBlend3 = function(frame1, frame2, frame3) {
	var pixelsLength = this.width * this.height;
	this.frames = 3;
	for (var i = 0; i < pixelsLength; i++) {
		var rgb1 = this.atari8Palette[frame1[i]];
		var rgb2 = this.atari8Palette[frame2[i]];
		var rgb3 = this.atari8Palette[frame3[i]];
		this.pixels[i] = Math.floor(((rgb1 >> 16) + (rgb2 >> 16) + (rgb3 >> 16)) / 3) << 16 | Math.floor(((rgb1 >> 8 & 255) + (rgb2 >> 8 & 255) + (rgb3 >> 8 & 255)) / 3) << 8 | Math.floor(((rgb1 & 255) + (rgb2 & 255) + (rgb3 & 255)) / 3);
	}
	return true;
}

FAIL.prototype.calculatePalette = function(palette, paletteOffset, paletteLength) {
	var pixelsCount = this.width * this.height;
	for (var pixelsOffset = 0; pixelsOffset < pixelsCount; pixelsOffset++) {
		var rgb = this.pixels[pixelsOffset];
		var index = FAIL.findColor(palette, paletteOffset, rgb);
		if (index >= paletteOffset || palette[index] != rgb) {
			if (paletteOffset == paletteLength) {
				this.colors = 0;
				return;
			}
			for (var j = paletteOffset; --j >= index;)
				palette[j + 1] = palette[j];
			palette[index] = rgb;
			paletteOffset++;
		}
	}
	this.colors = paletteOffset;
}
FAIL.COPYRIGHT = "This program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published\nby the Free Software Foundation; either version 2 of the License,\nor (at your option) any later version.";
FAIL.CREDITS = "First Atari Image Library (C) 2009-2013 Piotr Fusik and Adrian Matoga\n";

FAIL.prototype.decode = function(filename, content, contentLength) {
	switch (FAIL.getPackedExt(filename)) {
	case 3552562:
		return this.decode256(content, contentLength);
	case 6909236:
		return this.decode4mi(content, contentLength);
	case 7106612:
		return this.decode4pl(content, contentLength);
	case 7172148:
		return this.decode4pm(content, contentLength);
	case 7484513:
		return this.decodeA4r(content, contentLength);
	case 7562081:
		return this.decodeAcs(content, contentLength);
	case 7366497:
		return this.decodeAgp(content, contentLength);
	case 7105633:
		return this.decodeAll(content, contentLength);
	case 3305569:
		return this.decode256(content, contentLength);
	case 3371105:
	case 7762017:
	case 7366500:
	case 6517605:
	case 6515817:
	case 7174768:
		return this.decodeAp3(content, contentLength);
	case 6516833:
		return this.decodeApc(content, contentLength);
	case 7106657:
		return this.decodeApl(content, contentLength);
	case 7368801:
		return this.decodeApp(content, contentLength);
	case 7631457:
		return this.decodeArtDirector(content, contentLength) || this.decodeAtari8Artist(content, contentLength) || this.decodeAsciiArtEditor(content, contentLength);
	case 3762018:
	case 3747943:
		return this.decodeG09(content, contentLength);
	case 6777698:
		return this.decodeBkg(content, contentLength);
	case 7696994:
		return this.decodeBru(content, contentLength);
	case 3236195:
	case 3301731:
	case 3367267:
		return this.decodeCa(content, contentLength);
	case 6906723:
		return this.decodeCci(content, contentLength);
	case 7497827:
		return this.decodeChr(content, contentLength);
	case 7235939:
		return this.decodeCin(content, contentLength);
	case 7499875:
		return this.decodeCpr(content, contentLength);
	case 7630947:
		return this.decodeCpt(content, contentLength);
	case 3236708:
	case 6514532:
		return this.decodeDgc(content, contentLength);
	case 7103844:
		return this.decodeDel(content, contentLength);
	case 3237732:
	case 7694180:
		return this.decodeDgu(content, contentLength);
	case 7235940:
		return this.decodeDin(content, contentLength);
	case 7171172:
		return this.decodeDlm(content, contentLength);
	case 7303012:
		return this.decodeDoo(content, contentLength);
	case 6844516:
		return this.decodeDph(content, contentLength);
	case 6779492:
		return this.decodeDrg(content, contentLength);
	case 7630438:
		return this.decodeFnt(content, contentLength);
	case 6517862:
		return this.decodeFtc(content, contentLength);
	case 6387558:
		return this.decodeFwa(content, contentLength);
	case 6776935:
		return this.decodeGhg(content, contentLength);
	case 6582119:
		return this.decodeGod(content, contentLength);
	case 3158375:
		return this.decodeG10(content, contentLength);
	case 3223911:
		return this.decodeG11(content, contentLength);
	case 6448743:
		return this.decodeGfb(content, contentLength);
	case 3633767:
		return this.decodeGr7(content, 0, contentLength);
	case 3699303:
		return this.decodeGr8(content, contentLength);
	case 3764839:
		return this.decodeGr9(content, contentLength);
	case 7367016:
		return this.decodeHip(content, contentLength);
	case 7172200:
		return this.decodeHpm(content, contentLength);
	case 2126440:
		return this.decodeHr(content, contentLength);
	case 3306088:
		return this.decodeHr2(content, contentLength);
	case 7234409:
		return this.decodeStIcn(content, contentLength) || this.decodeAtari8Icn(content, contentLength);
	case 6710889:
	case 3239010:
	case 3304546:
	case 3370082:
		return this.decodeIff(content, contentLength);
	case 6645609:
		return this.decodeIge(content, contentLength);
	case 7236969:
		return this.decodeImn(content, contentLength);
	case 6778473:
	case 7368297:
		return this.decodeInp(content, contentLength);
	case 7630441:
		return this.decodeInt(content, contentLength) || this.decodeInp(content, contentLength);
	case 3305577:
		return this.decodeIp2(content, contentLength);
	case 6516841:
		return this.decodeIpc(content, contentLength);
	case 3306089:
		return this.decodeIr2(content, contentLength);
	case 6779497:
		return this.decodeIrg(content, contentLength);
	case 7631721:
		return this.decodeIst(content, contentLength);
	case 7366506:
		return this.decodeJgp(content, contentLength);
	case 7889261:
		return this.decodeMax(content, contentLength);
	case 6775405:
		return this.decodeMbg(content, contentLength);
	case 6841197:
		return this.decodeMch(content, contentLength);
	case 7365485:
		return this.decodeMcp(content, contentLength);
	case 7562093:
		return this.decodeMcs(content, contentLength);
	case 7366509:
		return this.decodeMgp(content, contentLength);
	case 6515053:
		return this.decodeMic(content, contentLength);
	case 7563629:
		return this.decodeMis(content, contentLength);
	case 7300462:
		return this.decodeNeo(content, contentLength);
	case 7433326:
		return this.decodeNlq(content, contentLength);
	case 6513008:
		return this.decodePac(content, contentLength);
	case 3236720:
	case 3302256:
	case 3367792:
		return this.decodePc(content, contentLength);
	case 7562096:
		return this.decodePcs(content, contentLength);
	case 6514544:
		return this.decodePgc(content, contentLength);
	case 6711152:
		return this.decodePgf(content, contentLength);
	case 3238256:
	case 3303792:
	case 3369328:
		return this.decodePi(content, contentLength);
	case 3434864:
	case 3762544:
		return this.decodePi4(content, contentLength);
	case 6515056:
		return this.decodePic(content, contentLength);
	case 6384752:
		return this.decodePla(content, contentLength);
	case 7171184:
		return this.decodeApc(content, contentLength);
	case 6581616:
		return this.decodePmd(content, contentLength);
	case 7823730:
		return this.decodeRaw(content, contentLength);
	case 6449010:
		return this.decodeRgb(content, contentLength);
	case 7367026:
		return this.decodeRip(content, contentLength);
	case 3173746:
		return this.decodeRm(content, contentLength, 0, FAILResolution.XE2X2);
	case 3239282:
		return this.decodeRm(content, contentLength, 1, FAILResolution.XE4X1);
	case 3304818:
		return this.decodeRm(content, contentLength, 2, FAILResolution.XE4X1);
	case 3370354:
		return this.decodeRm(content, contentLength, 3, FAILResolution.XE4X1);
	case 3435890:
		return this.decodeRm(content, contentLength, 4, FAILResolution.XE2X1);
	case 6645619:
		return this.decodeSge(content, contentLength);
	case 6514803:
		return this.decodeShc(content, contentLength);
	case 7366771:
		return this.decodeShp(content, contentLength);
	case 6516851:
		return this.decodeStSpc(content, contentLength) || this.decodeAtari8Spc(content, contentLength);
	case 7565427:
		return this.decodeSps(content, contentLength);
	case 7696499:
		return this.decodeSpu(content, contentLength);
	case 7567475:
		return this.decodeSxs(content, contentLength);
	case 7367028:
		return this.decodeTip(content, contentLength);
	case 3239540:
	case 3305076:
	case 3370612:
	case 7958132:
		return this.decodeTny(content, contentLength);
	case 7369332:
		return this.decodeTrp(content, contentLength);
	case 7697012:
		return this.decodeTru(content, contentLength);
	case 6912630:
		return this.decodeVzi(content, contentLength);
	case 6581879:
		return this.decodeWnd(content, contentLength);
	case 7367800:
		return this.decodeXlp(content, contentLength);
	default:
		return false;
	}
}

FAIL.prototype.decode256 = function(content, contentLength) {
	if (contentLength != 7680 && contentLength != 7684)
		return false;
	this.setSize(320, 192, FAILResolution.XE4X2);
	var frame = new Array(61440);
	this.gtiaColors[8] = 0;
	this.decodeAtari8Gr9(content, 3840, 40, frame, 320, 640, 320, 96);
	this.decodeAtari8Gr11PalBlend(content, 0, 40, frame, 0);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decode4mi = function(content, contentLength) {
	if (contentLength != 244)
		return false;
	this.setSize(32, 240, FAILResolution.XE2X1);
	var frame = new Array(7680);
	Ci.clearArray(frame, 0);
	this.decodeAt800Missiles(content, 4, frame, 0);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decode4pl = function(content, contentLength) {
	if (contentLength != 964)
		return false;
	this.setSize(80, 240, FAILResolution.XE2X1);
	var frame = new Array(19200);
	Ci.clearArray(frame, 0);
	this.decodeAt800Players(content, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decode4pm = function(content, contentLength) {
	if (contentLength != 1204)
		return false;
	this.setSize(112, 240, FAILResolution.XE2X1);
	var frame = new Array(26880);
	Ci.clearArray(frame, 0);
	this.decodeAt800Players(content, frame);
	this.decodeAt800Missiles(content, 964, frame, 80);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeA4r = function(content, contentLength) {
	var a4r = new A4rStream();
	a4r.content = content;
	a4r.contentOffset = 0;
	a4r.contentLength = contentLength;
	if (!a4r.unpackA4r())
		return false;
	this.setSize(320, 256, FAILResolution.XE4X1);
	var frame = new Array(81920);
	this.gtiaColors[8] = 0;
	this.decodeAtari8Gr9(a4r.unpacked, 512, 40, frame, 0, 320, 320, 256);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAcs = function(content, contentLength) {
	if (contentLength != 1028)
		return false;
	var characters = new Array(16);
	for (var i = 0; i < 16; i++)
		characters[i] = i;
	this.setBakPF012(content, 0, 1);
	this.setSize(128, 64, FAILResolution.XE2X1);
	var frame = new Array(8192);
	for (var y = 0; y < 8; y++)
		this.decodeAtari8Gr12Line(characters, 0, content, 4 + (y << 7), frame, y << 10);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAgp = function(content, contentLength) {
	if (contentLength != 7690)
		return false;
	this.setGtiaColors(content, 1);
	var frame = new Array(61440);
	switch (content[0]) {
	case 8:
		this.setSize(320, 192, FAILResolution.XE1X1);
		this.decodeAtari8Gr8(content, 10, frame);
		break;
	case 9:
		this.setSize(320, 192, FAILResolution.XE4X1);
		this.decodeAtari8Gr9(content, 10, 40, frame, 0, 320, 320, 192);
		break;
	case 10:
		this.setSize(320, 192, FAILResolution.XE4X1);
		this.gtiaLeftSkip = 2;
		this.decodeAtari8Gr10(content, 10, frame, 0, 320, 192);
		break;
	case 11:
		this.setSize(320, 192, FAILResolution.XE4X1);
		this.decodeAtari8Gr11(content, 10, frame, 0, 320, 192);
		break;
	case 15:
		this.setSize(320, 192, FAILResolution.XE2X1);
		this.decodeAtari8Gr15(content, 10, 40, frame, 0, 320, 192);
		break;
	default:
		return false;
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAll = function(content, contentLength) {
	if ((contentLength & 1023) != 989)
		return false;
	this.setPF0123Bak(content, contentLength - 5);
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame = new Array(61440);
	for (var y = 0; y < 24; y++) {
		var fontOffset = 24 + (content[y] << 10);
		if (fontOffset >= contentLength - 965)
			return false;
		this.decodeAtari8Gr12Line(content, contentLength - 965 + y * 40, content, fontOffset, frame, y * 2560);
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAp3 = function(content, contentLength) {
	var gr11Offset;
	switch (contentLength) {
	case 15360:
	case 15362:
		gr11Offset = 7680;
		break;
	case 15872:
		gr11Offset = 8192;
		break;
	default:
		return false;
	}
	this.setSize(320, 192, FAILResolution.XE4X1);
	this.gtiaColors[8] = 0;
	var frame1 = new Array(61440);
	this.decodeAtari8Gr9(content, 0, 80, frame1, 0, 640, 320, 96);
	this.decodeAtari8Gr11PalBlend(content, gr11Offset + 40, 80, frame1, 1);
	var frame2 = new Array(61440);
	this.decodeAtari8Gr9(content, 40, 80, frame2, 320, 640, 320, 96);
	this.decodeAtari8Gr11PalBlend(content, gr11Offset, 80, frame2, 0);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeApc = function(content, contentLength) {
	if (contentLength != 7680 && contentLength != 7720)
		return false;
	this.setSize(320, 192, FAILResolution.XE4X2);
	var frame = new Array(61440);
	this.gtiaColors[8] = 0;
	this.decodeAtari8Gr9(content, 40, 80, frame, 320, 640, 320, 96);
	this.decodeAtari8Gr11PalBlend(content, 0, 80, frame, 0);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeApl = function(content, contentLength) {
	if (contentLength != 1677 || content[0] != 154 || content[1] != 248 || content[2] != 57 || content[3] != 33)
		return false;
	var frames = content[4];
	var height = content[5];
	var gap = content[6];
	if (frames == 0 || frames > 16 || height == 0 || height > 48 || gap > 8)
		return false;
	var frameWidth = 8 + gap + 2 << 1;
	this.setSize(frames * frameWidth, height, FAILResolution.XE2X1);
	var frame = new Array(27648);
	Ci.clearArray(frame, 0);
	for (var f = 0; f < frames; f++) {
		this.decodeAtari8Player(content, 42 + f * 48, content[7 + f], frame, f * frameWidth, height);
		this.decodeAtari8Player(content, 858 + f * 48, content[24 + f], frame, f * frameWidth + gap * 2, height);
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeApp = function(content, contentLength) {
	if (contentLength < 7958 || !FAIL.isStringAt(content, 0, "S101") || content[4] != 0 || content[5] != 62)
		return false;
	var unpacked = new Array(15872);
	var unpackedOffset = 0;
	var bitStream = new BitStream();
	bitStream.content = content;
	bitStream.contentOffset = 22;
	bitStream.contentLength = contentLength;
	var current = bitStream.readBits(4);
	var hi = -1;
	for (;;) {
		if (hi < 0)
			hi = current;
		else {
			unpacked[unpackedOffset++] = hi << 4 | current;
			if (unpackedOffset >= 15872)
				break;
			hi = -1;
		}
		var code;
		var bit;
		for (code = 0;; code += 2) {
			bit = bitStream.readBit();
			if (bit == 0)
				break;
			if (bit < 0 || code >= 14)
				return false;
		}
		bit = bitStream.readBit();
		if (bit < 0)
			return false;
		code += bit;
		current = current - content[6 + code] & 15;
	}
	return this.decodeAp3(unpacked, 15872);
}

FAIL.prototype.decodeArtDirector = function(content, contentLength) {
	if (contentLength != 32512)
		return false;
	return this.decodeStLow(content, 0, content, 32000, 320, 200);
}

FAIL.prototype.decodeAsciiArtEditor = function(content, contentLength) {
	if (contentLength <= 0 || content[contentLength - 1] != 155)
		return false;
	var characters = new Array(1536);
	var columns = 1;
	var x = 0;
	var y = 0;
	for (var contentOffset = 0; contentOffset < contentLength; contentOffset++) {
		var ch = content[contentOffset];
		if (y >= 24)
			return false;
		if (ch == 155) {
			if (columns < x)
				columns = x;
			while (x < 64)
				characters[y * 64 + x++] = 0;
			x = 0;
			y++;
		}
		else {
			if (x >= 64)
				return false;
			characters[y * 64 + x++] = FAIL.toAtari8Char(ch);
		}
	}
	this.setSize(columns << 3, y << 3, FAILResolution.XE1X1);
	var frame = new Array(98304);
	this.decodeAtari8Gr0(characters, 64, FAIL.CI_BINARY_RESOURCE_ATARI8_FNT, 0, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAt800Missiles = function(content, contentOffset, frame, frameOffset) {
	for (var y = 0; y < 240; y++) {
		for (var i = 0; i < 4; i++) {
			var b = content[contentOffset + y] >> (i << 1);
			var offset = frameOffset + i * 4 * 2;
			frame[offset + 1] = frame[offset] = (b & 2) == 0 ? 0 : content[i];
			frame[offset + 3] = frame[offset + 2] = (b & 1) == 0 ? 0 : content[i];
		}
		frameOffset += this.width;
	}
}

FAIL.prototype.decodeAt800Players = function(content, frame) {
	for (var i = 0; i < 4; i++)
		this.decodeAtari8Player(content, 4 + i * 240, content[i], frame, i * 10 * 2, 240);
}

FAIL.prototype.decodeAtari8Artist = function(content, contentLength) {
	if (contentLength != 3206 || content[0] != 7)
		return false;
	this.setSize(320, 160, FAILResolution.XE2X2);
	var frame = new Array(51200);
	this.setPF0123Bak(content, 1);
	this.decodeAtari8Gr7(content, 6, frame, 0, 80);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAtari8Font = function(characters, font, fontOffset) {
	this.setSize(256, 32, FAILResolution.XE1X1);
	var frame = new Array(8192);
	this.decodeAtari8Gr0(characters, 32, font, fontOffset, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeAtari8Gr0 = function(characters, charactersStride, font, fontOffset, frame) {
	for (var y = 0; y < this.height; y++) {
		for (var x = 0; x < this.width; x++) {
			var ch = characters[(y >> 3) * charactersStride + (x >> 3)];
			var b = font[fontOffset + ((ch & 127) << 3) + (y & 7)];
			if (ch >= 128)
				b ^= 255;
			frame[y * this.width + x] = (b >> (~x & 7) & 1) == 0 ? 0 : 14;
		}
	}
}

FAIL.prototype.decodeAtari8Gr10 = function(content, contentOffset, frame, frameOffset, frameStride, height) {
	frameOffset += 2 - this.gtiaLeftSkip;
	for (var y = 0; y < height; y++) {
		var x;
		for (x = this.gtiaLeftSkip - 2; x < 0; x++)
			frame[frameOffset + x] = this.gtiaColors[0];
		for (; x < this.width + this.gtiaLeftSkip - 2; x++) {
			var c = content[contentOffset + (x >> 3)] >> (~x & 4) & 15;
			frame[frameOffset + x] = this.gtiaColors[c];
		}
		contentOffset += this.width >> 3;
		frameOffset += frameStride;
	}
}

FAIL.prototype.decodeAtari8Gr11 = function(content, contentOffset, frame, frameOffset, frameStride, height) {
	frameOffset -= this.gtiaLeftSkip;
	for (var y = 0; y < height; y++) {
		var x;
		for (x = this.gtiaLeftSkip; x < this.width; x++) {
			var c = content[contentOffset + (x >> 3)] << (x & 4) & 240;
			c = c == 0 ? this.gtiaColors[8] & 240 : this.gtiaColors[8] | c;
			frame[frameOffset + x] = c;
		}
		for (; x < this.width + this.gtiaLeftSkip; x++)
			frame[frameOffset + x] = this.gtiaColors[8] & 240;
		contentOffset += this.width >> 3;
		frameOffset += frameStride;
	}
}

FAIL.prototype.decodeAtari8Gr11PalBlend = function(content, contentOffset, contentStride, frame, y) {
	for (; y < this.height; y += 2) {
		var frameOffset = y * this.width - this.gtiaLeftSkip;
		var x;
		for (x = this.gtiaLeftSkip; x < this.width; x++) {
			var c = content[contentOffset + (x >> 3)] << (x & 4) & 240;
			var i = (y == 0 ? 0 : frame[frameOffset - this.width + x] & 15) + (y == this.height - 1 ? 0 : frame[frameOffset + this.width + x] & 15) >> 1;
			frame[frameOffset + x] = c | i;
			if (y < this.height - 1)
				frame[frameOffset + this.width + x] = c | frame[frameOffset + this.width + x] & 15;
		}
		for (; x < this.width + this.gtiaLeftSkip; x++)
			frame[frameOffset + x] = 0;
		contentOffset += contentStride;
	}
}

FAIL.prototype.decodeAtari8Gr12 = function(content, charactersOffset, fontOffset, frame) {
	for (var row = 0; row < 24; row++)
		this.decodeAtari8Gr12Line(content, charactersOffset + row * 40, content, fontOffset + (Math.floor(row / 3) << 11), frame, row * 2560);
}

FAIL.prototype.decodeAtari8Gr12Line = function(characters, charactersOffset, font, fontOffset, frame, frameOffset) {
	for (var y = 0; y < 8; y++) {
		for (var x = 0; x < this.width; x++) {
			var ch = characters[charactersOffset + (x >> 3)];
			var c = font[fontOffset + ((ch & 127) << 3) + y] >> (~x & 6) & 3;
			var gr12Registers = ch >= 128 ? 30024 : 25928;
			frame[frameOffset + x] = this.gtiaColors[gr12Registers >> (c << 2) & 15] & 254;
		}
		frameOffset += this.width;
	}
}

FAIL.prototype.decodeAtari8Gr15 = function(content, contentOffset, contentStride, frame, frameOffset, frameStride, height) {
	for (var y = 0; y < height; y++) {
		for (var x = 0; x < this.width; x++) {
			var c = content[contentOffset + (x >> 3)] >> (~x & 6) & 3;
			frame[frameOffset + x] = this.gtiaColors[c == 0 ? 8 : c + 3];
		}
		contentOffset += contentStride;
		frameOffset += frameStride;
	}
}

FAIL.prototype.decodeAtari8Gr7 = function(content, contentOffset, frame, frameOffset, height) {
	for (var y = 0; y < height; y++) {
		for (var x = 0; x < this.width; x++) {
			var c = content[contentOffset + (x >> 3)] >> (~x & 6) & 3;
			frame[frameOffset + x + this.width] = frame[frameOffset + x] = this.gtiaColors[c == 0 ? 8 : c + 3];
		}
		contentOffset += this.width >> 3;
		frameOffset += this.width << 1;
	}
}

FAIL.prototype.decodeAtari8Gr8 = function(content, contentOffset, frame) {
	var colors = new Array(2);
	colors[0] = this.gtiaColors[6];
	colors[1] = this.gtiaColors[6] & 240 | this.gtiaColors[5] & 14;
	var pixelsLength = this.width * this.height;
	for (var i = 0; i < pixelsLength; i++) {
		var c = content[contentOffset + (i >> 3)] >> (~i & 7) & 1;
		frame[i] = colors[c];
	}
}

FAIL.prototype.decodeAtari8Gr9 = function(content, contentOffset, contentStride, frame, frameOffset, frameStride, width, height) {
	for (var y = 0; y < height; y++) {
		for (var x = 0; x < width; x++) {
			var i = x + this.gtiaLeftSkip;
			var c = i < 0 || i >= width ? 0 : content[contentOffset + (i >> 3)] >> (~i & 4) & 15;
			frame[frameOffset + x] = this.gtiaColors[8] | c;
		}
		contentOffset += contentStride;
		frameOffset += frameStride;
	}
}

FAIL.prototype.decodeAtari8Icn = function(content, contentLength) {
	if (contentLength != 17350 || content[0] != 1)
		return false;
	var frame1 = new Array(61440);
	var screen2 = new Array(7680);
	this.setBakPF0123(content, 1);
	this.decodeIce(content, 6, frame1, screen2);
	var frame2 = new Array(61440);
	this.decodeAtari8Gr11(screen2, 0, frame2, 0, 320, 192);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeAtari8Player = function(content, contentOffset, color, frame, frameOffset, height) {
	color &= 254;
	for (var y = 0; y < height; y++) {
		var b = content[contentOffset + y];
		for (var x = 0; x < 8; x++) {
			var c = b >> 7 - x & 1;
			if (c != 0)
				frame[frameOffset + x * 2 + 1] = frame[frameOffset + x * 2] |= color;
		}
		frameOffset += this.width;
	}
}

FAIL.prototype.decodeAtari8Spc = function(content, contentLength) {
	if (contentLength < 3 || contentLength != content[0] + (content[1] << 8) + 3 || content[contentLength - 1] != 0)
		return false;
	var pixels = new Array(30720);
	Ci.clearArray(pixels, 0);
	var lineColors = new Array(96);
	Ci.clearArray(lineColors, 0);
	var textX = 0;
	var textY = 0;
	var lineX = 0;
	var lineY = 0;
	var brush = 0;
	var pattern = 8840;
	var lineColor = 3;
	var x;
	var y;
	for (var contentOffset = 2; content[contentOffset] != 0;) {
		switch (content[contentOffset]) {
		case 16:
			if (contentOffset + 3 >= contentLength)
				return false;
			textX = content[contentOffset + 1];
			textY = content[contentOffset + 2];
			contentOffset += 3;
			break;
		case 32:
		case 33:
		case 34:
		case 35:
			if (contentOffset + 1 >= contentLength)
				return false;
			lineColor = content[contentOffset] & 3;
			contentOffset++;
			break;
		case 48:
		case 80:
			if (contentOffset + 2 >= contentLength)
				return false;
			FAIL.drawSpcChar(pixels, textX, textY, content[contentOffset + 1]);
			textX += 4;
			contentOffset += 2;
			break;
		case 64:
		case 65:
		case 66:
		case 67:
		case 68:
		case 69:
		case 70:
		case 71:
			if (contentOffset + 1 >= contentLength)
				return false;
			brush = content[contentOffset] & 7;
			contentOffset++;
			break;
		case 96:
			if (contentOffset + 2 >= contentLength)
				return false;
			pattern = content[contentOffset + 1];
			if (pattern >= 71)
				return false;
			pattern = FAIL.CI_CONST_ARRAY_4[pattern];
			contentOffset += 2;
			break;
		case 112:
			if (contentOffset + 7 >= contentLength)
				return false;
			for (y = content[contentOffset + 1]; y <= content[contentOffset + 2]; y++) {
				if (y >= 96)
					return false;
				lineColors[y] = contentOffset + 3;
			}
			contentOffset += 7;
			break;
		case 128:
			if (contentOffset + 3 >= contentLength)
				return false;
			lineX = content[contentOffset + 1];
			lineY = content[contentOffset + 2];
			contentOffset += 3;
			break;
		case 160:
			if (contentOffset + 3 >= contentLength)
				return false;
			x = content[contentOffset + 1];
			y = content[contentOffset + 2];
			FAIL.drawSpcLine(pixels, lineX, lineY, x, y, lineColor);
			lineX = x;
			lineY = y;
			contentOffset += 3;
			break;
		case 192:
			if (contentOffset + 3 >= contentLength)
				return false;
			FAIL.drawSpcBrush(pixels, content[contentOffset + 1], content[contentOffset + 2], brush, pattern);
			contentOffset += 3;
			break;
		case 224:
			if (contentOffset + 3 >= contentLength)
				return false;
			if (!FAIL.fillSpc(pixels, content[contentOffset + 1], content[contentOffset + 2], pattern))
				return false;
			contentOffset += 3;
			break;
		default:
			return false;
		}
	}
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame = new Array(61440);
	for (y = 0; y < 192; y++) {
		var colorsOffset = lineColors[y >> 1];
		var colors = colorsOffset == 0 ? FAIL.CI_CONST_ARRAY_5 : content;
		for (x = 0; x < 160; x++) {
			var offset = y * 320 + x * 2;
			frame[offset + 1] = frame[offset] = colors[colorsOffset + pixels[y * 160 + x]] & 254;
		}
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeBitplanes = function(content, contentOffset, bitplanes, pixelsOffset, pixelsCount) {
	for (var i = 0; i < pixelsCount; i++) {
		var offset = contentOffset + (i >> 3 & ~1) * bitplanes + (i >> 3 & 1);
		var bit = ~i & 7;
		var c = 0;
		for (var bitplane = bitplanes; --bitplane >= 0;)
			c = c << 1 | content[offset + (bitplane << 1)] >> bit & 1;
		this.pixels[pixelsOffset + i] = this.atari16Palette[c];
	}
}

FAIL.prototype.decodeBkg = function(content, contentLength) {
	return contentLength == 3856 && this.decodeGr7(content, 0, 3844);
}

FAIL.prototype.decodeBlackAndWhite = function(content, contentOffset, width, height, resolution) {
	this.setSize(width, height, resolution);
	this.atari16Palette[0] = 16777215;
	this.atari16Palette[1] = 0;
	this.decodeBitplanes(content, contentOffset, 1, 0, width * height);
}

FAIL.prototype.decodeBlazingPaddlesVectors = function(content, contentLength, startAddress) {
	var x = 0;
	var y = 0;
	var i;
	var lineI = 0;
	var lineTop = 0;
	var lineBottom = 0;
	var xs = new Array(256);
	var ys = new Array(256);
	var width = 0;
	var box = new BlazingPaddlesBoundingBox();
	for (i = 0; i < 256; i++) {
		if (!box.calculate(content, contentLength, i, startAddress))
			break;
		var shapeWidth = box.right - box.left + 2;
		if (x + shapeWidth > 160) {
			y -= lineTop;
			while (lineI < i)
				ys[lineI++] = y;
			if (width < x)
				width = x + 3 & ~3;
			x = 0;
			y += lineBottom + 2;
			lineTop = box.top;
			lineBottom = box.bottom;
		}
		xs[i] = x - box.left;
		x += shapeWidth;
		if (lineTop > box.top)
			lineTop = box.top;
		if (lineBottom < box.bottom)
			lineBottom = box.bottom;
	}
	y -= lineTop;
	while (lineI < i)
		ys[lineI++] = y;
	if (width < x)
		width = x + 3 & ~3;
	y += lineBottom + 1;
	if (i == 0 || y > 240)
		return false;
	this.setSize(width * 2, y, FAILResolution.XE2X1);
	var frame = new Array(76800);
	Ci.clearArray(frame, 0);
	for (i = 0; i < 256; i++) {
		if (!this.drawBlazingPaddlesVector(content, contentLength, frame, (ys[i] * width + xs[i]) * 2, i, startAddress))
			break;
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeBru = function(content, contentLength) {
	if (contentLength != 64)
		return false;
	this.setSize(8, 8, FAILResolution.ST1X1);
	for (var i = 0; i < 64; i++) {
		switch (content[i]) {
		case 0:
			this.pixels[i] = 0;
			break;
		case 1:
			this.pixels[i] = 16777215;
			break;
		default:
			return false;
		}
	}
	return true;
}

FAIL.prototype.decodeCa = function(content, contentLength) {
	if (contentLength < 8 || content[0] != 67 || content[1] != 65)
		return false;
	var contentOffset;
	switch (content[3]) {
	case 0:
		contentOffset = 36;
		break;
	case 1:
		contentOffset = 12;
		break;
	case 2:
		contentOffset = 4;
		break;
	default:
		return false;
	}
	switch (content[2]) {
	case 0:
		if (contentOffset + 32000 != contentLength)
			return false;
		return this.decodeSt(content, contentOffset, content, 4, content[3]);
	case 1:
		var unpacked = new Array(32000);
		if (!CaStream.unpackCa(content, contentOffset, contentLength, unpacked, 0))
			return false;
		return this.decodeSt(unpacked, 0, content, 4, content[3]);
	default:
		return false;
	}
}

FAIL.prototype.decodeCci = function(content, contentLength) {
	if (contentLength < 24 || !FAIL.isStringAt(content, 0, "CIN 1.2 "))
		return false;
	var rle = new CciStream();
	rle.content = content;
	rle.contentOffset = 8;
	rle.contentLength = contentLength;
	var unpacked = new Array(16384);
	if (!rle.unpackGr15(unpacked, 0))
		return false;
	if (!rle.unpackGr15(unpacked, 40))
		return false;
	rle.contentOffset += 4;
	rle.repeatCount = 0;
	if (!rle.unpack(unpacked, 7680, 40, 7680))
		return false;
	rle.contentOffset += 4;
	rle.repeatCount = 0;
	if (!rle.unpack(unpacked, 15360, 1, 1024))
		return false;
	return this.decodeCin(unpacked, 16384);
}

FAIL.prototype.decodeChr = function(content, contentLength) {
	return contentLength == 3072 && this.decodeBlazingPaddlesVectors(content, contentLength, 28672);
}

FAIL.prototype.decodeCin = function(content, contentLength) {
	var height;
	switch (contentLength) {
	case 15360:
		this.setGr15DefaultColors();
		height = 192;
		break;
	case 16004:
		this.setBakPF012(content, 16000, 1);
		height = 200;
		break;
	case 16384:
		height = 192;
		break;
	default:
		return false;
	}
	this.setSize(320, height, FAILResolution.XE2X1);
	var frame1 = new Array(64000);
	var frame2 = new Array(64000);
	for (var y = 0; y < height; y++) {
		if (contentLength == 16384)
			this.setBakPF012(content, 15360 + y, 256);
		this.decodeAtari8Gr15(content, y * 40, 40, (y & 1) == 0 ? frame1 : frame2, y * 320, 320, 1);
	}
	this.decodeAtari8Gr11PalBlend(content, 40 * height + 40, 80, frame1, 1);
	this.decodeAtari8Gr11PalBlend(content, 40 * height, 80, frame2, 0);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeCpr = function(content, contentLength) {
	if (contentLength < 2)
		return false;
	var unpacked = new Array(7680);
	if (!KoalaStream.unpackKoala(content[0], content, 1, contentLength, unpacked, 7680))
		return false;
	this.gtiaColors[6] = 12;
	this.gtiaColors[5] = 0;
	this.setSize(320, 192, FAILResolution.XE1X1);
	var frame = new Array(61440);
	this.decodeAtari8Gr8(unpacked, 0, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeCpt = function(content, contentLength) {
	if (contentLength < 40 || content[32] != 0 || content[33] > 2)
		return false;
	var bitplanes = 4 >> content[33];
	var unpacked = new Array(32000);
	var isFilled = new Array(16000);
	Ci.clearArray(isFilled, 0);
	var contentOffset = 34;
	for (;;) {
		var nextContentOffset = contentOffset + 4 + bitplanes * 2;
		if (nextContentOffset > contentLength)
			return false;
		var repeatCount = content[contentOffset] << 8 | content[contentOffset + 1];
		if (repeatCount == 65535) {
			contentOffset = nextContentOffset;
			break;
		}
		var offset = (content[contentOffset + 2] << 8 | content[contentOffset + 3]) * bitplanes;
		do {
			if (offset >= 16000)
				return false;
			for (var bitplane = 0; bitplane < bitplanes; bitplane++) {
				unpacked[offset * 2] = content[contentOffset + 4 + bitplane * 2];
				unpacked[offset * 2 + 1] = content[contentOffset + 4 + bitplane * 2 + 1];
				isFilled[offset++] = 1;
			}
		}
		while (--repeatCount >= 0);
		contentOffset = nextContentOffset;
	}
	for (var offset = 0; offset < 16000; offset++) {
		if (isFilled[offset] == 0) {
			if (contentOffset + 1 >= contentLength)
				return false;
			unpacked[offset * 2] = content[contentOffset++];
			unpacked[offset * 2 + 1] = content[contentOffset++];
		}
	}
	return this.decodeSt(unpacked, 0, content, 0, content[33]);
}

FAIL.prototype.decodeDel = function(content, contentLength) {
	var unpacked = new Array(96000);
	if (!CaStream.unpackDel(content, contentLength, unpacked, 2))
		return false;
	return this.decodePi4(unpacked, 77824);
}

FAIL.prototype.decodeDgc = function(content, contentLength) {
	if (contentLength < 1042 || content[0] != 68 || content[1] != 71 || content[2] != 67 || content[3] > 3 || content[4] != 1 || content[5] != 64 || content[6] != 0 || content[7] != 200)
		return false;
	if (content[3] == 0) {
		if (contentLength != 65034)
			return false;
		this.decodeFalconPalette320(content, 1034, 10, 200);
		return true;
	}
	var unpacked = new Array(64000);
	var contentOffset = 1038;
	var valueBytes = 1 << content[3] - 1;
	var repeatCount = 0;
	for (var bitplane = 0; bitplane < 16; bitplane += 2) {
		for (var unpackedOffset = bitplane; unpackedOffset < 64000; unpackedOffset += 16) {
			for (var x = 0; x < 2; x++) {
				if (repeatCount == 0) {
					var nextContentOffset = contentOffset + content[3] * 2;
					if (nextContentOffset > contentLength)
						return false;
					switch (content[3]) {
					case 1:
						repeatCount = content[contentOffset] + 1;
						break;
					case 2:
						repeatCount = (content[contentOffset] << 8) + content[contentOffset + 1] + 1 << 1;
						break;
					case 3:
						repeatCount = (content[contentOffset] << 8) + content[contentOffset + 1] + 1 << 2;
						break;
					}
					contentOffset = nextContentOffset;
				}
				repeatCount--;
				unpacked[unpackedOffset + x] = content[contentOffset - valueBytes + (~repeatCount & valueBytes - 1)];
			}
		}
	}
	this.setFalconPalette(content, 10);
	this.setSize(320, 200, FAILResolution.FALCON1X1);
	this.decodeBitplanes(unpacked, 0, 8, 0, 64000);
	return true;
}

FAIL.prototype.decodeDgu = function(content, contentLength) {
	if (contentLength != 65032 || content[0] != 68 || content[1] != 71 || content[2] != 85 || content[3] != 1 || content[4] != 1 || content[5] != 64 || content[6] != 0 || content[7] != 200)
		return false;
	this.decodeFalconPalette320(content, 1032, 8, 200);
	return true;
}

FAIL.prototype.decodeDin = function(content, contentLength) {
	if (contentLength != 17351 || content[0] != 3)
		return false;
	var frame1 = new Array(61440);
	var screen2 = new Array(7680);
	this.setBakPF0123(content, 2);
	this.gtiaColors[8] = content[1] & 254;
	this.decodeIce(content, 1031, frame1, screen2);
	var frame2 = new Array(61440);
	this.setPF21(content, 1);
	this.decodeAtari8Gr8(screen2, 0, frame2);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeDlm = function(content, contentLength) {
	if (contentLength != 256)
		return false;
	var characters = new Array(176);
	for (var y = 0; y < 16; y++)
		for (var x = 0; x < 11; x++)
			characters[y * 11 + x] = FAIL.toAtari8Char(content[y * 16 + 5 + x]);
	this.setSize(88, 128, FAILResolution.XE1X1);
	var frame = new Array(11264);
	this.decodeAtari8Gr0(characters, 11, FAIL.CI_BINARY_RESOURCE_ATARI8_FNT, 0, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeDoo = function(content, contentLength) {
	if (contentLength != 32000)
		return false;
	this.decodeBlackAndWhite(content, 0, 640, 400, FAILResolution.ST1X1);
	return true;
}

FAIL.prototype.decodeDph = function(content, contentLength) {
	var unpacked = new Array(320000);
	if (!CaStream.unpackDel(content, contentLength, unpacked, 10)) {
		return false;
	}
	this.setFalconPalette(unpacked, 0);
	this.setSize(640, 480, FAILResolution.FALCON1X1);
	for (var y = 0; y < 240; y++) {
		this.decodeBitplanes(unpacked, 1024 + y * 320, 8, y * 640, 320);
		this.decodeBitplanes(unpacked, 77824 + y * 320, 8, y * 640 + 320, 320);
		this.decodeBitplanes(unpacked, 154624 + y * 320, 8, (240 + y) * 640, 320);
		this.decodeBitplanes(unpacked, 231424 + y * 320, 8, (240 + y) * 640 + 320, 320);
	}
	return true;
}

FAIL.prototype.decodeDrg = function(content, contentLength) {
	return contentLength == 6400 && this.decodeGr8(content, contentLength);
}

FAIL.prototype.decodeFalconPalette320 = function(content, bitplanesOffset, paletteOffset, height) {
	this.setFalconPalette(content, paletteOffset);
	this.setSize(320, height, FAILResolution.FALCON1X1);
	this.decodeBitplanes(content, bitplanesOffset, 8, 0, 320 * height);
}

FAIL.prototype.decodeFalconTrueColor = function(content, contentLength, contentOffset, width, height) {
	var pixelsCount = width * height;
	if (contentOffset + pixelsCount * 2 != contentLength)
		return false;
	this.setSize(width, height, FAILResolution.FALCON1X1);
	for (var i = 0; i < pixelsCount; i++) {
		var rg = content[contentOffset + i * 2];
		var gb = content[contentOffset + i * 2 + 1];
		var r = rg & 248 | rg >> 5;
		var g = (rg & 7) << 3 | gb >> 5;
		g = g << 2 | g >> 4;
		var b = gb & 31;
		b = b << 3 | b >> 2;
		this.pixels[i] = r << 16 | g << 8 | b;
	}
	return true;
}

FAIL.prototype.decodeFalconTrueColorVariable = function(content, contentLength, widthOffset, dataOffset) {
	var width = content[widthOffset] << 8 | content[widthOffset + 1];
	var height = content[widthOffset + 2] << 8 | content[widthOffset + 3];
	if (width > 640 || height > 560)
		return false;
	return this.decodeFalconTrueColor(content, contentLength, dataOffset, width, height);
}

FAIL.prototype.decodeFnt = function(content, contentLength) {
	var contentOffset;
	switch (contentLength) {
	case 1024:
	case 1025:
	case 1026:
		contentOffset = 0;
		break;
	case 1030:
		if (FAIL.parseAtari8ExecutableHeader(content, 0) != 1024)
			return false;
		contentOffset = 6;
		break;
	default:
		return false;
	}
	var characters = new Array(128);
	for (var i = 0; i < 128; i++)
		characters[i] = i;
	return this.decodeAtari8Font(characters, content, contentOffset);
}

FAIL.prototype.decodeFtc = function(content, contentLength) {
	return this.decodeFalconTrueColor(content, contentLength, 0, 384, 240);
}

FAIL.prototype.decodeFwa = function(content, contentLength) {
	if (contentLength < 7960 || content[0] != 254 || content[1] != 254 || content[6] != 112 || content[7] != 112 || content[8] != 112 || content[11] != 80 || content[115] != 96 || content[205] != 65 || 7960 + content[7958] + (content[7959] << 8) != contentLength)
		return false;
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame = new Array(61440);
	this.setBakPF012(content, 2, 1);
	var dlOffset = 9;
	var dliOffset = 7960;
	for (var y = 0; y < 192; y++) {
		this.decodeAtari8Gr15(content, 262 + 40 * y + (y >= 102 ? 16 : 0), 40, frame, y * 320, 320, 1);
		var dlInstr = content[dlOffset];
		if (dlOffset == 9 || dlOffset == 113) {
			if ((dlInstr & 127) != 78 || content[dlOffset + 1] != 0)
				return false;
			dlOffset += 3;
		}
		else {
			if ((dlInstr & 127) != 14)
				return false;
			dlOffset++;
		}
		if (dlInstr >= 128) {
			if (dliOffset + 14 > contentLength || content[dliOffset] != 72 || content[dliOffset + 1] != 138 || content[dliOffset + 2] != 72 || content[dliOffset + 3] != 169 || content[dliOffset + 5] != 141 || content[dliOffset + 6] != 10 || content[dliOffset + 7] != 212)
				return false;
			var a = content[dliOffset + 4];
			dliOffset += 8;
			while (content[dliOffset] != 32) {
				switch (content[dliOffset]) {
				case 169:
					a = content[dliOffset + 1];
					dliOffset += 2;
					break;
				case 141:
					if (content[dliOffset + 2] != 208)
						return false;
					var lo = content[dliOffset + 1];
					switch (lo) {
					case 22:
					case 23:
					case 24:
					case 26:
						this.gtiaColors[lo - 18] = a & 254;
						break;
					default:
						return false;
					}
					dliOffset += 3;
					break;
				default:
					return false;
				}
				if (dliOffset + 3 > contentLength)
					return false;
			}
			if (content[dliOffset + 1] != 202 || content[dliOffset + 2] != 6)
				return false;
			dliOffset += 3;
		}
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeG09 = function(content, contentLength) {
	switch (contentLength) {
	case 7680:
		return this.decodeGr9(content, contentLength);
	case 15360:
		break;
	default:
		return false;
	}
	this.setSize(640, 192, FAILResolution.XE4X1);
	this.gtiaColors[8] = 0;
	var frame = new Array(122880);
	this.decodeAtari8Gr9(content, 0, 40, frame, 0, 640, 320, 192);
	this.decodeAtari8Gr9(content, 7680, 40, frame, 320, 640, 320, 192);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeG10 = function(content, contentLength) {
	if (!this.setAtari8RawSize(content, contentLength, FAILResolution.XE4X1))
		return false;
	var contentOffset = FAIL.getAtari8ExecutableOffset(content, contentLength);
	if ((contentLength - contentOffset) % 40 != 9)
		return false;
	this.gtiaLeftSkip = 2;
	this.setGtiaColors(content, contentLength - 9);
	var frame = new Array(76800);
	this.decodeAtari8Gr10(content, contentOffset, frame, 0, 320, this.height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeG11 = function(content, contentLength) {
	if (!this.setAtari8RawSize(content, contentLength, FAILResolution.XE4X1))
		return false;
	this.gtiaColors[8] = 6;
	var contentOffset = FAIL.getAtari8ExecutableOffset(content, contentLength);
	var frame = new Array(76800);
	this.decodeAtari8Gr11(content, contentOffset, frame, 0, 320, this.height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeGfb = function(content, contentLength) {
	if (contentLength < 20 || !FAIL.isStringAt(content, 0, "GF25"))
		return false;
	var bitplanes;
	switch (FAIL.get32BigEndian(content, 4)) {
	case 2:
		bitplanes = 1;
		break;
	case 4:
		bitplanes = 2;
		break;
	case 16:
		bitplanes = 4;
		break;
	case 256:
		bitplanes = 8;
		break;
	default:
		return false;
	}
	var width = FAIL.get32BigEndian(content, 8);
	if (width <= 0 || width > 640 || (width & 15) != 0)
		return false;
	var height = FAIL.get32BigEndian(content, 12);
	if (height <= 0 || height > 560)
		return false;
	var bitmapLength = FAIL.get32BigEndian(content, 16);
	if (1556 + bitmapLength != contentLength || bitmapLength != (width >> 3) * bitplanes * height)
		return false;
	for (var i = 0; i < 1 << bitplanes; i++) {
		var j;
		switch (i) {
		case 1:
			j = (1 << bitplanes) - 1;
			break;
		case 2:
			j = 1;
			break;
		case 3:
			j = 2;
			break;
		case 5:
			j = 6;
			break;
		case 6:
			j = 3;
			break;
		case 7:
			j = 5;
			break;
		case 8:
			j = 7;
			break;
		case 9:
			j = 8;
			break;
		case 10:
			j = 9;
			break;
		case 11:
			j = 10;
			break;
		case 13:
			j = 14;
			break;
		case 14:
			j = 11;
			break;
		case 15:
			j = 13;
			break;
		case 255:
			j = 15;
			break;
		default:
			j = i;
			break;
		}
		var rgb = 0;
		for (var k = 0; k < 3; k++) {
			var offset = 20 + bitmapLength + (i * 3 + k) * 2;
			var c = content[offset] << 8 | content[offset + 1];
			if (c > 1000)
				return false;
			rgb = rgb << 8 | Math.floor(c * 255 / 1000);
		}
		this.atari16Palette[j] = rgb;
	}
	this.setSizeStOrFalcon(width, height, bitplanes);
	this.decodeBitplanes(content, 20, bitplanes, 0, width * height);
	return true;
}

FAIL.prototype.decodeGhg = function(content, contentLength) {
	if (contentLength < 4)
		return false;
	var width = (content[0] | content[1] << 8) + 7 & ~7;
	var height = content[2];
	if (width == 0 || width > 320 || height == 0 || height > 200)
		return false;
	this.setSize(width, height, FAILResolution.XE1X1);
	var frame = new Array(64000);
	this.gtiaColors[6] = 12;
	this.gtiaColors[5] = 2;
	this.decodeAtari8Gr8(content, 3, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeGod = function(content, contentLength) {
	return contentLength > 6 && this.decodeFalconTrueColorVariable(content, contentLength, 2, 6);
}

FAIL.prototype.decodeGr15Blend = function(content, bitmapOffset, colorsOffset, height) {
	this.setSize(320, height, FAILResolution.XE2X1);
	var frame1 = new Array(64000);
	this.setPF012Bak(content, colorsOffset);
	this.decodeAtari8Gr15(content, bitmapOffset, 80, frame1, 0, 640, height >> 1);
	this.setPF012Bak(content, colorsOffset + 4);
	this.decodeAtari8Gr15(content, bitmapOffset + 40, 80, frame1, 320, 640, height >> 1);
	var frame2 = new Array(64000);
	this.decodeAtari8Gr15(content, bitmapOffset + height * 40, 80, frame2, 0, 640, height >> 1);
	this.setPF012Bak(content, colorsOffset);
	this.decodeAtari8Gr15(content, bitmapOffset + height * 40 + 40, 80, frame2, 320, 640, height >> 1);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeGr7 = function(content, contentOffset, contentSize) {
	if (contentSize > 4804 || contentSize % 40 != 4)
		return false;
	var height = Math.floor(contentSize / 40);
	this.setSize(320, height * 2, FAILResolution.XE2X2);
	var frame = new Array(76800);
	this.setBakPF012(content, contentOffset + contentSize - 4, 1);
	this.decodeAtari8Gr7(content, contentOffset, frame, 0, height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeGr8 = function(content, contentLength) {
	if (!this.setAtari8RawSize(content, contentLength, FAILResolution.XE1X1))
		return false;
	this.gtiaColors[6] = 0;
	this.gtiaColors[5] = 14;
	var contentOffset = FAIL.getAtari8ExecutableOffset(content, contentLength);
	var frame = new Array(76800);
	this.decodeAtari8Gr8(content, contentOffset, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeGr9 = function(content, contentLength) {
	if (!this.setAtari8RawSize(content, contentLength, FAILResolution.XE4X1))
		return false;
	this.gtiaColors[8] = 0;
	var contentOffset = FAIL.getAtari8ExecutableOffset(content, contentLength);
	var frame = new Array(76800);
	this.decodeAtari8Gr9(content, contentOffset, 40, frame, 0, 320, 320, this.height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeHam = function(unpacked, width, height, bitplanes) {
	var holdBits = bitplanes > 6 ? 6 : 4;
	var i = 0;
	for (var y = 0; y < height; y++) {
		var rgb = this.atari16Palette[0];
		for (var x = 0; x < width; x++) {
			var offset = (i >> 3 & ~1) * bitplanes + (i >> 3 & 1);
			var bit = ~i & 7;
			var c = 0;
			for (var bitplane = bitplanes; --bitplane >= 0;)
				c = c << 1 | unpacked[offset + (bitplane << 1)] >> bit & 1;
			switch (c >> holdBits) {
			case 0:
				rgb = this.atari16Palette[c];
				break;
			case 1:
				c = c << 8 - holdBits & 255;
				c |= c >> holdBits;
				rgb = rgb & 16776960 | c;
				break;
			case 2:
				c = c << 8 - holdBits & 255;
				c |= c >> holdBits;
				rgb = rgb & 65535 | c << 16;
				break;
			case 3:
				c = c << 8 - holdBits & 255;
				c |= c >> holdBits;
				rgb = rgb & 16711935 | c << 8;
				break;
			}
			this.pixels[i++] = rgb;
		}
	}
}

FAIL.prototype.decodeHip = function(content, contentLength) {
	if (contentLength < 80)
		return false;
	var frame1 = new Array(76800);
	var frame2 = new Array(76800);
	var frameLength = FAIL.parseAtari8ExecutableHeader(content, 0);
	if (frameLength > 0 && frameLength % 40 == 0 && 12 + frameLength * 2 == contentLength && FAIL.parseAtari8ExecutableHeader(content, 6 + frameLength) == frameLength) {
		var height = Math.floor(frameLength / 40);
		if (height > 240)
			return false;
		this.setSize(320, height, FAILResolution.XE2X1);
		this.gtiaLeftSkip = 1;
		this.setGtiaColors(FAIL.CI_CONST_ARRAY_1, 0);
		this.decodeAtari8Gr10(content, 6, frame1, 0, 320, height);
		this.gtiaColors[8] = 0;
		this.decodeAtari8Gr9(content, 12 + frameLength, 40, frame2, 0, 320, 320, height);
	}
	else {
		var height = Math.floor(contentLength / 80);
		if (height > 240)
			return false;
		this.setSize(320, height, FAILResolution.XE2X1);
		this.gtiaLeftSkip = 1;
		this.gtiaColors[8] = 0;
		this.decodeAtari8Gr9(content, 0, 40, frame1, 0, 320, 320, height);
		if (contentLength % 80 == 9)
			this.setGtiaColors(content, contentLength - 9);
		else
			this.setGtiaColors(FAIL.CI_CONST_ARRAY_1, 0);
		this.decodeAtari8Gr10(content, height * 40, frame2, 0, 320, height);
	}
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeHpm = function(content, contentLength) {
	var unpacked = new Array(7684);
	var rle = new HpmStream();
	rle.content = content;
	rle.contentOffset = 0;
	rle.contentLength = contentLength;
	if (!rle.unpack(unpacked, 0, 1, 7680))
		return false;
	switch (rle.readByte()) {
	case 52:
	case 53:
		unpacked[7680] = 0;
		unpacked[7681] = 52;
		unpacked[7682] = contentLength == 3494 ? 56 : 200;
		unpacked[7683] = contentLength == 3494 ? 60 : 124;
		break;
	case 81:
		unpacked[7680] = 164;
		unpacked[7681] = 81;
		unpacked[7682] = 185;
		unpacked[7683] = 124;
		break;
	case 228:
		unpacked[7680] = 0;
		unpacked[7681] = 228;
		unpacked[7682] = 200;
		unpacked[7683] = 190;
		break;
	case 4:
		unpacked[7680] = 6;
		unpacked[7681] = 4;
		unpacked[7682] = 0;
		unpacked[7683] = 10;
		break;
	case 48:
		unpacked[7680] = 14;
		unpacked[7681] = 48;
		unpacked[7682] = 199;
		unpacked[7683] = 123;
		break;
	case 116:
		unpacked[7680] = 0;
		unpacked[7681] = 116;
		unpacked[7682] = 88;
		unpacked[7683] = 126;
		break;
	default:
		unpacked[7680] = 0;
		unpacked[7681] = 4;
		unpacked[7682] = 8;
		unpacked[7683] = 12;
		break;
	}
	return this.decodeMic(unpacked, 7684);
}

FAIL.prototype.decodeHr = function(content, contentLength) {
	if (contentLength != 16384)
		return false;
	this.setSize(256, 239, FAILResolution.XE1X1);
	this.gtiaColors[6] = 0;
	this.gtiaColors[5] = 14;
	var frame1 = new Array(61184);
	this.decodeAtari8Gr8(content, 0, frame1);
	var frame2 = new Array(61184);
	this.decodeAtari8Gr8(content, 8192, frame2);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeHr2 = function(content, contentLength) {
	if (contentLength != 16006)
		return false;
	this.setSize(320, 200, FAILResolution.XE1X1);
	var frame1 = new Array(64000);
	this.setPF21(content, 16000);
	this.decodeAtari8Gr8(content, 0, frame1);
	var frame2 = new Array(64000);
	this.setBakPF012(content, 16002, 1);
	this.decodeAtari8Gr15(content, 8000, 40, frame2, 0, 320, 200);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIce = function(content, contentOffset, frame1, screen2) {
	this.setSize(320, 192, contentOffset >= 16 ? FAILResolution.XE1X1 : FAILResolution.XE2X1);
	var screen2Offset = 0;
	for (var row = 0; row < 24; row++) {
		var charactersOffset = (contentOffset & 15) + 16384 + row * 40;
		var fontOffset = contentOffset + (Math.floor(row / 3) << 11);
		this.decodeAtari8Gr12Line(content, charactersOffset, content, fontOffset, frame1, row * 2560);
		for (var y = 0; y < 8; y++) {
			for (var x = 0; x < 40; x++) {
				var ch = content[charactersOffset + x] & 127;
				screen2[screen2Offset++] = content[(fontOffset ^ 1024) + (ch << 3) + y];
			}
		}
	}
}

FAIL.prototype.decodeIff = function(content, contentLength) {
	if (contentLength < 56 || !FAIL.isStringAt(content, 0, "FORM"))
		return false;
	var contentOffset = 8;
	if (FAIL.isStringAt(content, 8, "DPSTDPAH") && FAIL.get32BigEndian(content, 16) == 24 && FAIL.isStringAt(content, 44, "FORM"))
		contentOffset = 52;
	if (!FAIL.isStringAt(content, contentOffset, "ILBM") && !FAIL.isStringAt(content, contentOffset, "ACBM"))
		return false;
	contentOffset += 4;
	var width = 0;
	var height = 0;
	var bitplanes = 0;
	var hasMask = false;
	var compression = 0;
	var colors = 0;
	var camg = 0;
	while (contentOffset + 7 < contentLength) {
		var chunkLength = FAIL.get32BigEndian(content, contentOffset + 4);
		if (contentOffset + 8 + chunkLength > contentLength)
			break;
		if (FAIL.isStringAt(content, contentOffset, "BMHD") && chunkLength >= 11) {
			width = content[contentOffset + 8] << 8 | content[contentOffset + 9];
			height = content[contentOffset + 10] << 8 | content[contentOffset + 11];
			bitplanes = content[contentOffset + 16];
			hasMask = content[contentOffset + 17] == 1;
			compression = content[contentOffset + 18];
			if (width == 0 || width > 640 || height == 0 || height > 560 || bitplanes == 0 || bitplanes > 8 && bitplanes != 24 && bitplanes != 32 || compression > 2)
				return false;
			width = width + 15 & ~15;
		}
		else if (FAIL.isStringAt(content, contentOffset, "CMAP")) {
			colors = Math.floor(chunkLength / 3);
			if (colors > 256)
				return false;
			var c;
			for (c = 0; c < colors; c++) {
				var offset = contentOffset + 8 + c * 3;
				this.atari16Palette[c] = content[offset] << 16 | content[offset + 1] << 8 | content[offset + 2];
			}
			for (; c < 256; c++)
				this.atari16Palette[c] = 0;
		}
		else if (FAIL.isStringAt(content, contentOffset, "CAMG") && chunkLength >= 4)
			camg = FAIL.get32BigEndian(content, contentOffset + 8);
		else if (FAIL.isStringAt(content, contentOffset, "BODY")) {
			if (width == 0)
				return false;
			var bytesPerLine = (width >> 3) * bitplanes;
			var unpacked = new Array(bytesPerLine * height);
			if (compression == 2) {
				var rle = new VdatStream();
				rle.content = content;
				rle.contentOffset = contentOffset + 8;
				for (var bitplane = 0; bitplane < bitplanes; bitplane++) {
					if (rle.contentOffset + 14 > contentLength || !FAIL.isStringAt(content, rle.contentOffset, "VDAT"))
						return false;
					var nextContentOffset = rle.contentOffset + 8 + FAIL.get32BigEndian(content, rle.contentOffset + 4);
					if (nextContentOffset > contentOffset + 8 + chunkLength)
						return false;
					rle.valueOffset = rle.contentLength = rle.contentOffset + 8 + (content[rle.contentOffset + 8] << 8) + content[rle.contentOffset + 9];
					rle.valueLength = nextContentOffset;
					rle.contentOffset += 10;
					for (var x = bitplane << 1; x < bytesPerLine; x += bitplanes << 1) {
						var unpackedOffset = x;
						for (var y = 0; y < height; y++) {
							var b = rle.readRle();
							if (b < 0)
								return false;
							unpacked[unpackedOffset] = b >> 8;
							unpacked[unpackedOffset + 1] = b & 0xff;
							unpackedOffset += bytesPerLine;
						}
					}
					rle.contentOffset = nextContentOffset;
				}
			}
			else {
				var rle = new PackBitsStream();
				rle.content = content;
				rle.contentOffset = contentOffset + 8;
				rle.contentLength = contentOffset + 8 + chunkLength;
				for (var y = 0; y < height; y++) {
					for (var bitplane = 0; bitplane < bitplanes; bitplane++) {
						for (var w = bitplane << 1; w < bytesPerLine; w += bitplanes << 1) {
							for (var x = 0; x < 2; x++) {
								var b = compression == 0 ? rle.readByte() : rle.readRle();
								if (b < 0)
									return false;
								unpacked[y * bytesPerLine + w + x] = b;
							}
						}
					}
					if (hasMask) {
						for (var x = 0; x < width; x += 8) {
							var b = compression == 0 ? rle.readByte() : rle.readRle();
							if (b < 0)
								return false;
						}
					}
				}
			}
			this.decodeIffUnpacked(unpacked, width, height, bitplanes, colors, camg);
			return true;
		}
		else if (FAIL.isStringAt(content, contentOffset, "ABIT")) {
			if (width == 0 || compression != 0 || chunkLength != (width >> 3) * height * bitplanes)
				return false;
			contentOffset += 8;
			var unpacked = new Array(chunkLength);
			for (var bitplane = 0; bitplane < bitplanes; bitplane++) {
				for (var unpackedOffset = bitplane << 1; unpackedOffset < chunkLength; unpackedOffset += bitplanes << 1) {
					for (var x = 0; x < 2; x++)
						unpacked[unpackedOffset + x] = content[contentOffset++];
				}
			}
			this.decodeIffUnpacked(unpacked, width, height, bitplanes, colors, camg);
			return true;
		}
		contentOffset += 8 + (chunkLength + 1 & ~1);
	}
	return false;
}

FAIL.prototype.decodeIffUnpacked = function(unpacked, width, height, bitplanes, colors, camg) {
	var pixelsCount = width * height;
	if (camg != 0)
		this.setSize(width, height, FAILResolution.AMIGA1X1);
	else
		this.setSizeStOrFalcon(width, height, bitplanes);
	if (bitplanes <= 8) {
		if (colors == 0) {
			colors = 1 << bitplanes;
			for (var c = 0; c < colors; c++)
				this.atari16Palette[c] = Math.floor(c * 255 / colors) * 65793;
		}
		else if ((camg & 2176) == 128 && bitplanes == 6 && colors < 64) {
			for (var c = 0; c < 32; c++)
				this.atari16Palette[32 + c] = this.atari16Palette[c] >> 1 & 8355711;
		}
		if ((camg & 2048) != 0) {
			this.decodeHam(unpacked, width, height, bitplanes);
		}
		else {
			this.decodeBitplanes(unpacked, 0, bitplanes, 0, pixelsCount);
		}
	}
	else {
		for (var i = 0; i < pixelsCount; i++) {
			var offset = (i >> 3 & ~1) * bitplanes + (i >> 3 & 1);
			var bit = ~i & 7;
			var c = 0;
			for (var bitplane = 24; --bitplane >= 0;)
				c = c << 1 | unpacked[offset + (bitplane << 1)] >> bit & 1;
			this.pixels[i] = (c & 255) << 16 | c & 65280 | c >> 16;
		}
	}
}

FAIL.prototype.decodeIge = function(content, contentLength) {
	if (contentLength != 6160 || content[0] != 255 || content[1] != 255 || content[2] != 246 || content[3] != 163 || content[4] != 255 || content[5] != 187 || content[6] != 255 || content[7] != 95)
		return false;
	this.setSize(256, 96, FAILResolution.XE2X1);
	var frame1 = new Array(24576);
	this.setBakPF012(content, 8, 1);
	this.decodeAtari8Gr15(content, 16, 32, frame1, 0, 256, 96);
	var frame2 = new Array(24576);
	this.setBakPF012(content, 12, 1);
	this.decodeAtari8Gr15(content, 3088, 32, frame2, 0, 256, 96);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeImn = function(content, contentLength) {
	if (contentLength != 17350 || content[0] != 1)
		return false;
	var frame1 = new Array(61440);
	var screen2 = new Array(7680);
	this.setBakPF0123(content, 1);
	this.decodeIce(content, 6, frame1, screen2);
	var frame2 = new Array(61440);
	this.decodeAtari8Gr9(screen2, 0, 40, frame2, 0, 320, 320, 192);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeInp = function(content, contentLength) {
	if (contentLength < 16004)
		return false;
	this.setSize(320, 200, FAILResolution.XE2X1);
	this.setBakPF012(content, 16000, 1);
	var frame1 = new Array(64000);
	this.decodeAtari8Gr15(content, 0, 40, frame1, 0, 320, 200);
	var frame2 = new Array(64000);
	this.decodeAtari8Gr15(content, 8000, 40, frame2, 0, 320, 200);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeInt = function(content, contentLength) {
	if (contentLength < 18 || !FAIL.isStringAt(content, 0, "INT95a") || content[8] != 15 || content[9] != 43)
		return false;
	var contentStride = content[6];
	var height = content[7];
	if (contentStride == 0 || contentStride > 320 || height == 0 || height > 239 || 18 + contentStride * height * 2 != contentLength)
		return false;
	var width = contentStride << 3;
	this.setSize(width, height, FAILResolution.XE2X1);
	var frame1 = new Array(76480);
	this.setBakPF012(content, 10, 1);
	this.decodeAtari8Gr15(content, 18, contentStride, frame1, 0, width, height);
	var frame2 = new Array(76480);
	this.setBakPF012(content, 14, 1);
	this.decodeAtari8Gr15(content, 18 + contentStride * height, contentStride, frame2, 0, width, height);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIp2 = function(content, contentLength) {
	if (contentLength != 17358 || content[0] != 1)
		return false;
	var frame1 = new Array(61440);
	var screen2 = new Array(7680);
	this.gtiaColors[8] = content[1] & 254;
	this.gtiaColors[4] = content[5] & 254;
	this.gtiaColors[5] = content[7] & 254;
	this.gtiaColors[6] = content[9] & 254;
	this.gtiaColors[7] = content[11] & 254;
	this.decodeIce(content, 14, frame1, screen2);
	var frame2 = new Array(61440);
	this.gtiaLeftSkip = 2;
	for (var i = 0; i < 4; i++) {
		this.gtiaColors[i] = content[1 + i] & 254;
		this.setGtiaColor(4 + i, content[6 + i * 2]);
	}
	this.setGtiaColor(8, content[13]);
	this.decodeAtari8Gr10(screen2, 0, frame2, 0, 320, 192);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIpc = function(content, contentLength) {
	if (contentLength != 17354 || content[0] != 1)
		return false;
	var frame1 = new Array(61440);
	var screen2 = new Array(7680);
	this.setPF0123Bak(content, 5);
	this.gtiaColors[8] = content[1] & 254;
	this.decodeIce(content, 10, frame1, screen2);
	var frame2 = new Array(61440);
	this.gtiaLeftSkip = 2;
	this.setGtiaColors(content, 1);
	this.decodeAtari8Gr10(screen2, 0, frame2, 0, 320, 192);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIr2 = function(content, contentLength) {
	if (contentLength != 18314 || content[0] != 1)
		return false;
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame1 = new Array(61440);
	this.gtiaColors[8] = content[1] & 254;
	this.setPF0123Even(content, 2);
	this.decodeAtari8Gr12(content, 16394, 10, frame1);
	var frame2 = new Array(61440);
	this.setPF0123Even(content, 3);
	this.decodeAtari8Gr12(content, 17354, 1034, frame2);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIrg = function(content, contentLength) {
	if (contentLength != 18310 || content[0] != 1)
		return false;
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame1 = new Array(61440);
	this.setBakPF0123(content, 1);
	this.decodeAtari8Gr12(content, 16390, 6, frame1);
	var frame2 = new Array(61440);
	this.decodeAtari8Gr12(content, 17350, 1030, frame2);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeIst = function(content, contentLength) {
	if (contentLength != 17184)
		return false;
	this.setSize(320, 200, FAILResolution.XE2X1);
	var frame1 = new Array(64000);
	var frame2 = new Array(64000);
	for (var y = 0; y < 200; y++) {
		this.setBakPF012(content, 16384 + y, 200);
		this.decodeAtari8Gr15(content, 16 + y * 40, 0, frame1, y * 320, 320, 1);
		this.decodeAtari8Gr15(content, 8208 + y * 40, 0, frame2, y * 320, 320, 1);
	}
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeJgp = function(content, contentLength) {
	if (contentLength != 2054 || FAIL.parseAtari8ExecutableHeader(content, 0) != 2048)
		return false;
	var characters = new Array(32);
	for (var i = 0; i < 32; i++)
		characters[i] = i;
	this.setGr15DefaultColors();
	this.setSize(256, 64, FAILResolution.XE2X1);
	var frame = new Array(16384);
	for (var y = 0; y < 8; y++)
		this.decodeAtari8Gr12Line(characters, 0, content, 6 + ((y & 6) << 7) + ((y & 1) << 10), frame, y << 11);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMax = function(content, contentLength) {
	if (contentLength < 1732 || !FAIL.isStringAt(content, 0, "XLPM"))
		return false;
	var rle = new XlpStream();
	rle.content = content;
	rle.contentOffset = 1732;
	rle.contentLength = contentLength;
	var unpacked = new Array(15360);
	if (!rle.unpack(unpacked, 0, 40, 15360))
		return false;
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame1 = new Array(61440);
	var frame2 = new Array(61440);
	for (var y = 0; y < 192; y++) {
		this.setBakPF012(content, 772 + y, 192);
		this.decodeAtari8Gr15(unpacked, y * 40, 40, frame1, y * 320, 320, 1);
		this.setBakPF012(content, 4 + y, 192);
		this.decodeAtari8Gr15(unpacked, 7680 + y * 40, 40, frame2, y * 320, 320, 1);
	}
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeMbg = function(content, contentLength) {
	if (contentLength != 16384)
		return false;
	this.setSize(512, 256, FAILResolution.XE1X1);
	this.gtiaColors[6] = 0;
	this.gtiaColors[5] = 14;
	var frame = new Array(131072);
	this.decodeAtari8Gr8(content, 0, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMch = function(content, contentLength) {
	var width;
	var charactersStride;
	var charactersOffset;
	switch (contentLength) {
	case 9840:
		width = 128;
		charactersStride = 32;
		charactersOffset = 0;
		break;
	case 12000:
		width = 160;
		charactersStride = 40;
		charactersOffset = 0;
		break;
	case 14160:
		width = 176;
		charactersStride = 48;
		charactersOffset = 3;
		break;
	default:
		return false;
	}
	this.setSize(width * 2, 240, FAILResolution.XE2X1);
	var frame = new Array(84480);
	for (var y = 0; y < 240; y++) {
		var colorsOffset = contentLength - 1200 + y;
		for (var x = 0; x < width; x++) {
			var offset = (charactersOffset + (y >> 3) * charactersStride + (x >> 2)) * 9;
			var c = content[offset + 1 + (y & 7)] >> (~x & 3) * 2 & 3;
			if (c == 3 && content[offset] >= 128)
				c = 4;
			offset = (y * width + x) * 2;
			frame[offset + 1] = frame[offset] = content[colorsOffset + c * 240] & 254;
		}
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMcp = function(content, contentLength) {
	if (contentLength != 16008)
		return false;
	return this.decodeGr15Blend(content, 0, 16000, 200);
}

FAIL.prototype.decodeMcs = function(content, contentLength) {
	if (contentLength != 10185)
		return false;
	this.setSize(320, 192, FAILResolution.XE2X1);
	var frame = new Array(61440);
	for (var y = 0; y < 192; y++) {
		var fontOffset = 9 + (Math.floor(y / 24) << 10);
		for (var x = 0; x < 320; x++) {
			var ch = content[8201 + (y >> 3) * 40 + (x >> 3)];
			var c;
			switch (content[fontOffset + ((ch & 127) << 3) + (y & 7)] >> (~x & 6) & 3) {
			case 0:
				c = Math.floor(x / 80);
				var pmgBit = (x >> 3) % 10;
				var pmgOffset;
				if (pmgBit < 8) {
					pmgBit = 7 - pmgBit;
					pmgOffset = 9305 + (c << 7);
				}
				else {
					pmgBit = c << 1 | pmgBit ^ 9;
					pmgOffset = 9177;
				}
				if ((content[pmgOffset + (y >> 1)] >> pmgBit & 1) == 0)
					c = 8;
				break;
			case 1:
				c = 4;
				break;
			case 2:
				c = 5;
				break;
			default:
				c = 6 + (ch >> 7);
				break;
			}
			frame[y * 320 + x] = content[c] & 254;
		}
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMgp = function(content, contentLength) {
	if (contentLength != 3845)
		return false;
	this.setSize(320, 192, FAILResolution.XE2X2);
	var frame = new Array(61440);
	this.setPF0123Bak(content, 0);
	var rainbow = content[5];
	var bitmap = new Array(3840);
	Ci.copyArray(content, 6, bitmap, 0, 3839);
	bitmap[3839] = 0;
	for (var y = 0; y < 96; y++) {
		if (rainbow < 4) {
			this.gtiaColors[rainbow == 0 ? 8 : 3 + rainbow] = 16 + y & 254;
		}
		this.decodeAtari8Gr7(bitmap, y * 40, frame, y * 640, 1);
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMic = function(content, contentLength) {
	if (contentLength == 15872) {
		contentLength = 7680;
		this.setPF012Bak(content, 7680);
	}
	else {
		switch (contentLength % 40) {
		case 0:
		case 3:
			this.setGr15DefaultColors();
			break;
		case 4:
			this.setBakPF012(content, contentLength - 4, 1);
			break;
		case 5:
			this.setPF012Bak(content, contentLength - 5);
			break;
		default:
			return false;
		}
	}
	var height = Math.floor(contentLength / 40);
	if (height == 0 || height > 240)
		return false;
	this.setSize(320, height, FAILResolution.XE2X1);
	var frame = new Array(76800);
	this.decodeAtari8Gr15(content, 0, 40, frame, 0, 320, height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeMis = function(content, contentLength) {
	if (contentLength != 61 && contentLength != 241)
		return false;
	this.setSize(4, 240, FAILResolution.XE2X1);
	var frame = new Array(960);
	for (var y = 0; y < 240; y++) {
		var b = content[1 + (y >> 2)] >> ((~y & 3) << 1);
		frame[y * 4 + 1] = frame[y * 4] = (b & 2) == 0 ? 0 : content[0];
		frame[y * 4 + 3] = frame[y * 4 + 2] = (b & 1) == 0 ? 0 : content[0];
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeNeo = function(content, contentLength) {
	if (contentLength != 32128 || content[0] != 0 || content[1] != 0 || content[2] != 0)
		return false;
	return this.decodeSt(content, 128, content, 4, content[3]);
}

FAIL.prototype.decodeNlq = function(content, contentLength) {
	if (contentLength < 379 || !FAIL.isStringAt(content, 0, "DAISY-DOT NLQ FONT") || content[18] != 155)
		return false;
	this.setSize(320, 96, FAILResolution.XE1X1);
	var frame = new Array(30720);
	Ci.clearArray(frame, 0);
	var contentOffset = 19;
	for (var i = 0; i < 91; i++) {
		if (contentOffset >= contentLength)
			return false;
		var width = content[contentOffset];
		if (width == 0 || width > 19)
			return false;
		var nextContentOffset = contentOffset + (width + 1) * 2;
		if (nextContentOffset > contentLength || content[nextContentOffset - 1] != 155)
			return false;
		var c = i < 64 ? i : i < 90 ? i + 1 : 92;
		for (var y = 0; y < 16; y++) {
			for (var x = 0; x < width; x++) {
				var b = content[contentOffset + 1 + (y & 1) * width + x] >> 7 - (y >> 1) & 1;
				frame[(c & 240 | y) * 320 + (c & 15) * 20 + x] = b == 0 ? 0 : 14;
			}
		}
		contentOffset = nextContentOffset;
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodePac = function(content, contentLength) {
	if (contentLength < 8 || content[0] != 112 || content[1] != 77 || content[2] != 56)
		return false;
	var unpackedStride;
	switch (content[3]) {
	case 53:
		unpackedStride = 1;
		break;
	case 54:
		unpackedStride = 80;
		break;
	default:
		return false;
	}
	var rle = new PacStream();
	rle.content = content;
	rle.contentOffset = 7;
	rle.contentLength = contentLength;
	var unpacked = new Array(32000);
	if (!rle.unpack(unpacked, 0, unpackedStride, 32000))
		return false;
	return this.decodeDoo(unpacked, 32000);
}

FAIL.prototype.decodePc = function(content, contentLength) {
	if (contentLength < 68 || content[0] != 128 || content[1] > 2)
		return false;
	var bitplanes = 4 >> content[1];
	var rle = new PackBitsStream();
	rle.content = content;
	rle.contentOffset = 34;
	rle.contentLength = contentLength;
	var unpacked = new Array(32000);
	for (var y = 0; y < 200; y++) {
		for (var bitplane = 0; bitplane < bitplanes; bitplane++) {
			for (var x = 0; x < 40 << content[1]; x++) {
				var b = rle.readRle();
				if (b < 0)
					return false;
				unpacked[y * 160 + (x & ~1) * bitplanes + (bitplane << 1) + (x & 1)] = b;
			}
		}
	}
	return this.decodeSt(unpacked, 0, content, 2, content[1]);
}

FAIL.prototype.decodePcs = function(content, contentLength) {
	if (contentLength < 18 || content[0] != 1 || content[1] != 64 || content[2] != 0 || content[3] != 200)
		return false;
	var rle = new PcsStream();
	rle.content = content;
	rle.contentOffset = 6;
	rle.contentLength = contentLength;
	var unpacked1 = new Array(51232);
	if (!rle.unpackPcs(unpacked1))
		return false;
	this.setSize(320, 199, FAIL.isStePalette(unpacked1, 32000, 9616) ? FAILResolution.STE1X1 : FAILResolution.ST1X1);
	this.decodePcsScreen(unpacked1, 0);
	if (content[4] == 0)
		return true;
	this.frames = 2;
	rle.repeatCount = 0;
	var unpacked2 = new Array(51232);
	if (!rle.unpackPcs(unpacked2))
		return false;
	if ((content[4] & 1) == 0) {
		for (var i = 0; i < 32000; i++)
			unpacked2[i] ^= unpacked1[i];
	}
	if ((content[4] & 2) == 0) {
		for (var i = 32000; i < 51232; i++)
			unpacked2[i] ^= unpacked1[i];
	}
	this.decodePcsScreen(unpacked2, 63680);
	for (var i = 0; i < 63680; i++) {
		var rgb1 = this.pixels[i];
		var rgb2 = this.pixels[63680 + i];
		this.pixels[i] = (rgb1 & rgb2) + ((rgb1 ^ rgb2) >> 1 & 8355711);
	}
	return true;
}

FAIL.prototype.decodePcsScreen = function(unpacked, pixelsOffset) {
	for (var y = 0; y < 199; y++) {
		for (var x = 0; x < 320; x++) {
			var bitmapOffset = 40 + y * 40 + (x >> 3);
			var bit = ~x & 7;
			var c = (unpacked[bitmapOffset] >> bit & 1) << 1 | (unpacked[8000 + bitmapOffset] >> bit & 1) << 2 | (unpacked[16000 + bitmapOffset] >> bit & 1) << 3 | (unpacked[24000 + bitmapOffset] >> bit & 1) << 4;
			if (x >= c * 2) {
				if (c < 28) {
					if (x >= c * 2 + 76) {
						if (x >= 176 + c * 5 - (c & 2) * 3)
							c += 32;
						c += 32;
					}
				}
				else if (x >= c * 2 + 92)
					c += 32;
				c += 32;
			}
			this.pixels[pixelsOffset++] = this.getStColor(unpacked, 32000 + y * 96 + c);
		}
	}
}

FAIL.prototype.decodePgc = function(content, contentLength) {
	if (contentLength < 33 || content[0] != 80 || content[1] != 71 || content[2] != 1)
		return false;
	var rle = new PgcStream();
	rle.content = content;
	rle.contentOffset = 3;
	rle.contentLength = contentLength;
	var unpacked = new Array(1920);
	for (var unpackedOffset = 0; unpackedOffset < 1920; unpackedOffset++) {
		var b = rle.readRle();
		if (b < 0) {
			if (unpackedOffset == 1919)
				b = 0;
			else
				return false;
		}
		unpacked[unpackedOffset] = b;
	}
	return this.decodePgf(unpacked, 1920);
}

FAIL.prototype.decodePgf = function(content, contentLength) {
	if (contentLength != 1920)
		return false;
	this.decodeBlackAndWhite(content, 0, 240, 64, FAILResolution.PORTFOLIO1X1);
	return true;
}

FAIL.prototype.decodePi = function(content, contentLength) {
	if (contentLength < 32034 || content[0] != 0)
		return false;
	switch (contentLength) {
	case 32034:
	case 32066:
	case 32128:
		return this.decodeSt(content, 34, content, 2, content[1]);
	case 44834:
		if (content[1] != 0)
			return false;
		return this.decodeStLow(content, 34, content, 2, 320, 280);
	case 116514:
		if (content[1] != 0)
			return false;
		return this.decodeStLow(content, 34, content, 2, 416, 560);
	default:
		return false;
	}
}

FAIL.prototype.decodePi4 = function(content, contentLength) {
	var height;
	switch (contentLength) {
	case 65024:
		height = 200;
		break;
	case 77824:
		height = 240;
		break;
	default:
		return false;
	}
	this.decodeFalconPalette320(content, 1024, 0, height);
	return true;
}

FAIL.prototype.decodePic = function(content, contentLength) {
	var unpacked = new Array(7680);
	if (KoalaStream.unpackKoalaWrapped(content, contentLength, unpacked, 7680)) {
		this.setSize(320, 192, FAILResolution.XE2X1);
		this.setPF0123Bak(content, 13);
		var frame = new Array(61440);
		this.decodeAtari8Gr15(unpacked, 0, 40, frame, 0, 320, 192);
		return this.applyAtari8Palette(frame);
	}
	if (contentLength == 7680)
		return this.decodeGr8(content, contentLength);
	if (contentLength >= 7681 && contentLength <= 7685)
		return this.decodeMic(content, contentLength);
	return this.decodeDoo(content, contentLength);
}

FAIL.prototype.decodePla = function(content, contentLength) {
	if (contentLength != 241)
		return false;
	this.setSize(16, 240, FAILResolution.XE2X1);
	var frame = new Array(3840);
	Ci.clearArray(frame, 0);
	this.decodeAtari8Player(content, 1, content[0], frame, 0, 240);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodePmd = function(content, contentLength) {
	if (contentLength < 12 || content[0] != 240 || content[1] != 237 || content[2] != 228)
		return false;
	var sprites = content[7];
	var shapes = content[8] * content[9];
	var totalShapes = sprites * shapes;
	var height = content[10];
	if (sprites == 0 || sprites > 4 || shapes == 0 || shapes > 160 || height == 0 || height > 48 || 11 + totalShapes * height != contentLength)
		return false;
	if (true)
		totalShapes >>= 1;
	var rows = totalShapes + 15 >> 4;
	if (rows == 1)
		this.setSize(totalShapes * 20, height, FAILResolution.XE2X1);
	else {
		var totalHeight = rows * height + (rows - 1) * 2;
		if (totalHeight > 560)
			return false;
		this.setSize(320, totalHeight, FAILResolution.XE2X1);
	}
	var frame = new Array(179200);
	Ci.clearArray(frame, 0);
	for (var shape = 0; shape < totalShapes; shape++) {
		var frameOffset = (shape >> 4) * (height + 2) * 320 + (shape & 15) * 20;
		if (true) {
			var spritePair = Math.floor(shape / shapes);
			var contentOffset = 11 + (spritePair * shapes + shape) * height;
			this.decodeAtari8Player(content, contentOffset, content[3 + spritePair * 2], frame, frameOffset, height);
			this.decodeAtari8Player(content, contentOffset + shapes * height, content[4 + spritePair * 2], frame, frameOffset, height);
		}
		else
			this.decodeAtari8Player(content, 11 + shape * height, content[3 + Math.floor(shape / shapes)], frame, frameOffset, height);
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeRaw = function(content, contentLength) {
	if (contentLength != 15372 || !FAIL.isStringAt(content, 0, "XLPB"))
		return false;
	return this.decodeGr15Blend(content, 4, 15364, 192);
}

FAIL.prototype.decodeRgb = function(content, contentLength) {
	if (contentLength < 9 || !FAIL.isStringAt(content, 0, "RGB1"))
		return false;
	var titleLength = content[4];
	var width = content[6 + titleLength];
	var height = content[7 + titleLength];
	if (width == 0 || (width & 1) != 0 || width > 80 || height == 0 || height > 192 || content[8 + titleLength] != 1)
		return false;
	switch (content[5 + titleLength]) {
	case 9:
		this.setSize(width << 2, height, FAILResolution.XE4X1);
		break;
	case 15:
		this.setSize(width << 2, height, FAILResolution.XE2X1);
		break;
	default:
		return false;
	}
	var leftRgbs = new Array(192);
	var screens = new Array(23040);
	var rle = new RgbStream();
	rle.content = content;
	rle.contentOffset = 9 + titleLength;
	rle.contentLength = contentLength;
	for (var x = 0; x < width; x++) {
		for (var y = 0; y < height; y++) {
			var rgb = rle.readRle();
			if (rgb < 0)
				return false;
			if ((x & 1) == 0)
				leftRgbs[y] = rgb;
			else {
				var leftRgb = leftRgbs[y];
				var screenOffset = y * 40 + (x >> 1);
				screens[screenOffset] = leftRgb >> 4 & 240 | rgb >> 8;
				screens[7680 + screenOffset] = leftRgb & 240 | rgb >> 4 & 15;
				screens[15360 + screenOffset] = leftRgb << 4 & 240 | rgb & 15;
			}
		}
	}
	var frame1 = new Array(61440);
	this.decodeRgbScreen(screens, 0, 48, frame1);
	var frame2 = new Array(61440);
	this.decodeRgbScreen(screens, 7680, 192, frame2);
	var frame3 = new Array(61440);
	this.decodeRgbScreen(screens, 15360, 112, frame3);
	return this.applyAtari8PaletteBlend3(frame1, frame2, frame3);
}

FAIL.prototype.decodeRgbScreen = function(screens, screensOffset, color, frame) {
	if (this.resolution == FAILResolution.XE4X1) {
		this.gtiaColors[8] = color;
		this.decodeAtari8Gr9(screens, screensOffset, 40, frame, 0, this.width, this.width, this.height);
	}
	else {
		this.gtiaColors[8] = 0;
		this.gtiaColors[4] = color | 4;
		this.gtiaColors[5] = color | 10;
		this.gtiaColors[6] = color | 14;
		this.decodeAtari8Gr15(screens, screensOffset, 40, frame, 0, this.width, this.height);
	}
}

FAIL.prototype.decodeRip = function(content, contentLength) {
	if (contentLength < 34 || content[0] != 82 || content[1] != 73 || content[2] != 80 || content[18] != 84 || content[19] != 58)
		return false;
	var headerLength = content[11] | content[12] << 8;
	var contentStride = content[13];
	var height = content[15];
	var textLength = content[17];
	if (headerLength >= contentLength || contentStride == 0 || contentStride > 80 || (contentStride & 1) != 0 || height == 0 || height > 239 || 33 + textLength >= contentLength || content[20 + textLength] != 9 || !FAIL.isStringAt(content, 21 + textLength, "CM:"))
		return false;
	if (content[7] < 16)
		contentStride >>= 1;
	var unpackedLength = contentStride * height;
	if (content[7] == 48)
		unpackedLength += height + 1 >> 1 << 3;
	var unpacked = new Array(20076);
	Ci.clearArray(unpacked, 0);
	switch (content[9]) {
	case 0:
		if (headerLength + unpackedLength > contentLength)
			return false;
		Ci.copyArray(content, headerLength, unpacked, 0, unpackedLength);
		break;
	case 1:
		this.unpackRip(content, headerLength, contentLength, unpacked, unpackedLength);
		break;
	default:
		return false;
	}
	this.setGtiaColors(content, 24 + textLength);
	contentStride = content[13] >> 1;
	var width = contentStride << 3;
	var frame1 = new Array(76480);
	var frame2 = new Array(76480);
	switch (content[7]) {
	case 14:
		this.setSize(width, height, FAILResolution.XE2X1);
		this.decodeAtari8Gr15(unpacked, 0, contentStride, frame1, 0, width, height);
		return this.applyAtari8Palette(frame1);
	case 15:
		this.setSize(width, height, FAILResolution.XE1X1);
		this.decodeAtari8Gr8(unpacked, 0, frame1);
		return this.applyAtari8Palette(frame1);
	case 79:
		this.setSize(width, height, FAILResolution.XE4X1);
		this.decodeAtari8Gr9(unpacked, 0, contentStride, frame1, 0, width, width, height);
		return this.applyAtari8Palette(frame1);
	case 143:
		this.setSize(width, height, FAILResolution.XE4X1);
		this.gtiaLeftSkip = 2;
		this.decodeAtari8Gr10(unpacked, 0, frame1, 0, width, height);
		return this.applyAtari8Palette(frame1);
	case 207:
		this.setSize(width, height, FAILResolution.XE4X1);
		this.decodeAtari8Gr11(content, 0, frame1, 0, width, height);
		return this.applyAtari8Palette(frame1);
	case 30:
		this.setSize(width, height, FAILResolution.XE2X1);
		this.decodeAtari8Gr15(unpacked, 0, contentStride, frame1, 0, width, height);
		this.decodeAtari8Gr15(unpacked, height * contentStride, contentStride, frame2, 0, width, height);
		return this.applyAtari8PaletteBlend(frame1, frame2);
	case 16:
		this.setSize(width, height, FAILResolution.XE2X1);
		this.setBakPF012(content, 28 + textLength, 1);
		this.decodeAtari8Gr15(unpacked, 0, contentStride << 1, frame1, 0, width << 1, height >> 1);
		this.setBakPF012(content, 24 + textLength, 1);
		this.decodeAtari8Gr15(unpacked, contentStride, contentStride << 1, frame1, width, width << 1, height >> 1);
		this.decodeAtari8Gr15(unpacked, height * contentStride, contentStride << 1, frame2, 0, width << 1, height >> 1);
		this.setBakPF012(content, 28 + textLength, 1);
		this.decodeAtari8Gr15(unpacked, (height + 1) * contentStride, contentStride << 1, frame2, width, width << 1, height >> 1);
		return this.applyAtari8PaletteBlend(frame1, frame2);
	case 32:
		this.setSize(width, height, FAILResolution.XE2X1);
		this.gtiaLeftSkip = 1;
		this.decodeAtari8Gr10(unpacked, 0, frame1, 0, width, height);
		this.gtiaColors[8] = 0;
		this.decodeAtari8Gr9(unpacked, height * contentStride, contentStride, frame2, 0, width, width, height);
		return this.applyAtari8PaletteBlend(frame1, frame2);
	case 48:
		this.setSize(width, height, FAILResolution.XE2X1);
		this.gtiaLeftSkip = 1;
		this.gtiaColors[0] = 0;
		var colorsOffset = height * contentStride << 1;
		for (var y = 0; y < height; y += 2) {
			this.setPM123PF0123Bak(unpacked, colorsOffset + (y << 2));
			this.decodeAtari8Gr10(unpacked, y * contentStride, frame1, y * width, width, y + 1 < height ? 2 : 1);
		}
		this.gtiaColors[8] = 0;
		this.decodeAtari8Gr9(unpacked, height * contentStride, contentStride, frame2, 0, width, width, height);
		return this.applyAtari8PaletteBlend(frame1, frame2);
	default:
		return false;
	}
}

FAIL.prototype.decodeRm = function(content, contentLength, mode, resolution) {
	var unpacked = new Array(7680);
	var colorsOffset;
	var dliOffset;
	if (KoalaStream.unpackKoalaWrapped(content, contentLength - 464, unpacked, mode == 0 ? 3840 : 7680)) {
		colorsOffset = contentLength - 464;
		dliOffset = contentLength - 384;
	}
	else if (contentLength == 8192) {
		Ci.copyArray(content, 0, unpacked, 0, 7680);
		colorsOffset = 7680;
		dliOffset = 7808;
	}
	else
		return false;
	var dliPresent = new Array(192);
	Ci.clearArray(dliPresent, false);
	for (var i = 0; i < 128; i++) {
		var y = content[dliOffset + i];
		switch (y) {
		case 0:
			break;
		case 1:
		case 2:
		case 4:
		case 5:
			return false;
		default:
			if (mode == 0) {
				if (y >= 101)
					return false;
				if (y == 3)
					y = 0;
				else
					y -= 5;
			}
			else {
				if (y == 100 || y == 101 || y >= 198)
					return false;
				if (y == 3)
					y = 1;
				else if (y < 100)
					y -= 4;
				else
					y -= 6;
			}
			dliPresent[y] = true;
			break;
		}
	}
	this.setSize(320, 192, resolution);
	if (mode == 2)
		this.gtiaLeftSkip = 2;
	if (mode == 1)
		this.gtiaColors[8] = content[colorsOffset + 8] & 240;
	else
		this.setGtiaColors(content, colorsOffset);
	var height = mode == 0 ? 96 : 192;
	var frame = new Array(61440);
	for (var y = 0; y < height; y++) {
		switch (mode) {
		case 0:
			this.decodeAtari8Gr7(unpacked, y * 40, frame, y * 640, 1);
			break;
		case 1:
			this.decodeAtari8Gr9(unpacked, y * 40, 40, frame, y * 320, 320, 320, 1);
			break;
		case 2:
			this.decodeAtari8Gr10(unpacked, y * 40, frame, y * 320, 320, 1);
			break;
		case 3:
			this.decodeAtari8Gr11(unpacked, y * 40, frame, y * 320, 320, 1);
			break;
		case 4:
			this.decodeAtari8Gr15(unpacked, y * 40, 40, frame, y * 320, 320, 1);
			break;
		}
		if (dliPresent[y]) {
			var vcount = mode == 0 ? 16 + y : 16 + (y - 1 >> 1);
			var reg = content[dliOffset + 128 + vcount];
			if (reg < 9)
				this.setGtiaColor(reg, content[dliOffset + 256 + vcount]);
			else if (reg != 128)
				return false;
		}
	}
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeSge = function(content, contentLength) {
	if (contentLength != 960)
		return false;
	var font = new Array(1024);
	Ci.copyArray(FAIL.CI_BINARY_RESOURCE_ATARI8_FNT, 0, font, 0, 1024);
	for (var i = 0; i < 4; i++) {
		font[1004 + i] = font[728 + i] = 15;
		font[1000 + i] = font[732 + i] = 240;
	}
	this.setSize(320, 192, FAILResolution.XE1X1);
	var frame = new Array(61440);
	this.decodeAtari8Gr0(content, 40, font, 0, frame);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeShc = function(content, contentLength) {
	if (contentLength != 17920)
		return false;
	this.setSize(320, 192, FAILResolution.XE1X1);
	var frame1 = new Array(61440);
	var frame2 = new Array(61440);
	var col1 = 15360;
	var col2 = 16640;
	for (var y = 0; y < 192; y++) {
		for (var x = 0; x < 320; x++) {
			var i = 320 * y + x;
			var bit = ~x & 7;
			switch (x) {
			case 94:
			case 166:
			case 214:
			case 262:
			case 306:
				col1++;
				break;
			case 46:
			case 142:
			case 190:
			case 238:
			case 286:
				col2++;
				break;
			default:
				break;
			}
			frame1[i] = content[col1] & ((content[i >> 3] >> bit & 1) != 0 ? 240 : 254);
			frame2[i] = content[col2] & ((content[7680 + (i >> 3)] >> bit & 1) != 0 ? 240 : 254);
		}
		col1++;
		col2++;
	}
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeShp = function(content, contentLength) {
	switch (contentLength) {
	case 1024:
		return this.decodeBlazingPaddlesVectors(content, contentLength, 31744);
	case 4384:
		return this.decodeGr7(content, 528, 3844);
	default:
		return false;
	}
}

FAIL.prototype.decodeSps = function(content, contentLength) {
	if (contentLength < 13 || content[0] != 83 || content[1] != 80 || content[2] != 0 || content[3] != 0)
		return false;
	var unpacked = new Array(51104);
	var rle = new SpsStream();
	rle.content = content;
	rle.contentOffset = 12;
	rle.contentLength = contentLength;
	if ((content[contentLength - 1] & 1) == 0) {
		for (var bitplane = 0; bitplane < 8; bitplane += 2) {
			for (var x = 0; x < 40; x++) {
				for (var unpackedOffset = 160 + ((x & ~1) << 2) + bitplane + (x & 1); unpackedOffset < 32000; unpackedOffset += 160) {
					var b = rle.readRle();
					if (b < 0)
						return false;
					unpacked[unpackedOffset] = b;
				}
			}
		}
	}
	else {
		if (!FAIL.unpackSpc(rle, unpacked))
			return false;
	}
	var bitStream = new BitStream();
	bitStream.content = content;
	bitStream.contentOffset = 12 + FAIL.get32BigEndian(content, 4);
	bitStream.contentLength = contentLength;
	for (var unpackedOffset = 32000; unpackedOffset < 51104;) {
		var got = bitStream.readBits(14);
		if (got < 0)
			return false;
		got <<= 1;
		for (var i = 15; i >= 0; i--) {
			var rgb;
			if ((got >> i & 1) == 0)
				rgb = 0;
			else {
				rgb = bitStream.readBits(9);
				if (rgb < 0)
					return false;
			}
			unpacked[unpackedOffset] = rgb >> 6;
			unpacked[unpackedOffset + 1] = (rgb & 63) + (rgb & 56);
			unpackedOffset += 2;
		}
	}
	return this.decodeSpu(unpacked, 51104);
}

FAIL.prototype.decodeSpu = function(content, contentLength) {
	if (contentLength != 51104)
		return false;
	this.setSize(320, 199, FAIL.isStePalette(content, 32000, 9552) ? FAILResolution.STE1X1 : FAILResolution.ST1X1);
	var pixelsOffset = 0;
	for (var y = 0; y < 199; y++) {
		for (var x = 0; x < 320; x++) {
			var bitmapOffset = 160 + (pixelsOffset >> 1 & ~7) + (x >> 3 & 1);
			var bit = ~x & 7;
			var c = (content[bitmapOffset] >> bit & 1) << 1 | (content[bitmapOffset + 2] >> bit & 1) << 2 | (content[bitmapOffset + 4] >> bit & 1) << 3 | (content[bitmapOffset + 6] >> bit & 1) << 4;
			var x1 = c * 5 + 1 - (c & 2) * 3;
			if (x >= x1 + 160)
				c += 64;
			else if (x >= x1)
				c += 32;
			this.pixels[pixelsOffset++] = this.getStColor(content, 32000 + y * 96 + c);
		}
	}
	return true;
}

FAIL.prototype.decodeSt = function(bitmap, bitmapOffset, palette, paletteOffset, mode) {
	switch (mode) {
	case 0:
		return this.decodeStLow(bitmap, bitmapOffset, palette, paletteOffset, 320, 200);
	case 1:
		this.decodeStMedium(bitmap, bitmapOffset, palette, paletteOffset);
		return true;
	case 2:
		this.decodeBlackAndWhite(bitmap, bitmapOffset, 640, 400, FAILResolution.ST1X1);
		return true;
	default:
		return false;
	}
}

FAIL.prototype.decodeStIcn = function(content, contentLength) {
	var parser = new IcnParser();
	parser.content = content;
	parser.contentOffset = 0;
	parser.contentLength = contentLength;
	var width = parser.parseDefine("ICON_W");
	if (width <= 0 || width >= 640)
		return false;
	var height = parser.parseDefine("ICON_H");
	if (height <= 0 || height >= 560)
		return false;
	var size = parser.parseDefine("ICONSIZE");
	if (size != (width + 15 >> 4) * height)
		return false;
	if (!parser.expect("int") || !parser.expect("image[ICONSIZE]") || !parser.expect("=") || !parser.expect("{"))
		return false;
	var bitmap = new Array(44800);
	for (var i = 0;;) {
		var value = parser.parseHex();
		if (value < 0)
			return false;
		bitmap[i * 2] = value >> 8;
		bitmap[i * 2 + 1] = value & 0xff;
		if (++i >= size)
			break;
		if (parser.contentOffset >= contentLength || content[parser.contentOffset++] != 44)
			return false;
	}
	if (!parser.expect("};"))
		return false;
	this.decodeBlackAndWhite(bitmap, 0, width + 15 & ~15, height, FAILResolution.ST1X1);
	return true;
}

FAIL.prototype.decodeStLow = function(bitmap, bitmapOffset, palette, paletteOffset, width, height) {
	this.setSize(width, height, FAIL.isStePalette(palette, paletteOffset, 16) ? FAILResolution.STE1X1 : FAILResolution.ST1X1);
	this.setStPalette(palette, paletteOffset, 16);
	this.decodeBitplanes(bitmap, bitmapOffset, 4, 0, width * height);
	return true;
}

FAIL.prototype.decodeStMedium = function(bitmap, bitmapOffset, palette, paletteOffset) {
	this.setSize(640, 400, FAIL.isStePalette(palette, paletteOffset, 4) ? FAILResolution.STE1X2 : FAILResolution.ST1X2);
	this.setStPalette(palette, paletteOffset, 4);
	for (var y = 0; y < 200; y++) {
		for (var x = 0; x < 640; x++) {
			var offset = bitmapOffset + y * 160 + (x >> 2 & ~3) + (x >> 3 & 1);
			var bit = ~x & 7;
			var c = bitmap[offset] >> bit & 1 | (bitmap[offset + 2] >> bit & 1) << 1;
			var pixelsOffset = y * 1280 + x;
			this.pixels[pixelsOffset + 640] = this.pixels[pixelsOffset] = this.atari16Palette[c];
		}
	}
}

FAIL.prototype.decodeStSpc = function(content, contentLength) {
	if (contentLength < 12 || content[0] != 83 || content[1] != 80)
		return false;
	var unpacked = new Array(51104);
	var rle = new SpcStream();
	rle.content = content;
	rle.contentOffset = 12;
	rle.contentLength = contentLength;
	if (!FAIL.unpackSpc(rle, unpacked))
		return false;
	var contentOffset = 12 + FAIL.get32BigEndian(content, 4);
	for (var unpackedOffset = 32000; unpackedOffset < 51104;) {
		if (contentOffset + 1 >= contentLength)
			return false;
		var got = content[contentOffset] << 8 | content[contentOffset + 1];
		contentOffset += 2;
		for (var i = 0; i < 16; i++) {
			if ((got >> i & 1) == 0) {
				unpacked[unpackedOffset] = 0;
				unpacked[unpackedOffset + 1] = 0;
			}
			else {
				if (contentOffset + 1 >= contentLength)
					return false;
				unpacked[unpackedOffset] = content[contentOffset];
				unpacked[unpackedOffset + 1] = content[contentOffset + 1];
				contentOffset += 2;
			}
			unpackedOffset += 2;
		}
	}
	return this.decodeSpu(unpacked, 51104);
}

FAIL.prototype.decodeSxs = function(content, contentLength) {
	if (contentLength != 1030 || FAIL.parseAtari8ExecutableHeader(content, 0) != 1024)
		return false;
	var characters = new Array(128);
	for (var i = 0; i < 128; i++)
		characters[i] = i & 65 | i >> 4 & 2 | (i & 30) << 1;
	return this.decodeAtari8Font(characters, content, 6);
}

FAIL.prototype.decodeTip = function(content, contentLength) {
	if (contentLength < 129 || content[0] != 84 || content[1] != 73 || content[2] != 80 || content[3] != 1 || content[4] != 0)
		return false;
	var width = content[5];
	var height = content[6];
	if (width > 160 || (width & 3) != 0 || height > 119)
		return false;
	var contentStride = width >> 2;
	var frameLength = content[7] | content[8] << 8;
	if (frameLength != contentStride * height || contentLength != 9 + 3 * frameLength)
		return false;
	this.setSize(width << 1, height << 1, FAILResolution.XE2X2);
	this.gtiaLeftSkip = 1;
	this.setGtiaColors(FAIL.CI_CONST_ARRAY_2, 0);
	var frame1 = new Array(76160);
	this.decodeAtari8Gr9(content, 9, contentStride, frame1, width << 1, width << 2, width << 1, height);
	this.decodeAtari8Gr11PalBlend(content, 9 + 2 * frameLength, contentStride, frame1, 0);
	var frame2 = new Array(76160);
	this.decodeAtari8Gr10(content, 9 + frameLength, frame2, width << 1, width << 2, height);
	this.decodeAtari8Gr11PalBlend(content, 9 + 2 * frameLength, contentStride, frame2, 0);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeTny = function(content, contentLength) {
	if (contentLength < 42)
		return false;
	var mode = content[0];
	var contentOffset;
	if (mode > 2) {
		if (mode > 5)
			return false;
		mode -= 3;
		contentOffset = 4;
	}
	else
		contentOffset = 0;
	var controlLength = content[contentOffset + 33] << 8 | content[contentOffset + 34];
	var valueLength = (content[contentOffset + 35] << 8 | content[contentOffset + 36]) << 1;
	if (contentOffset + 37 + controlLength + valueLength > contentLength)
		return false;
	var rle = new TnyStream();
	rle.content = content;
	rle.contentOffset = contentOffset + 37;
	rle.valueOffset = rle.contentLength = contentOffset + 37 + controlLength;
	rle.valueLength = contentOffset + 37 + controlLength + valueLength;
	var unpacked = new Array(32000);
	for (var bitplane = 0; bitplane < 8; bitplane += 2) {
		for (var x = bitplane; x < 160; x += 8) {
			for (var unpackedOffset = x; unpackedOffset < 32000; unpackedOffset += 160) {
				var b = rle.readRle();
				if (b < 0)
					return false;
				unpacked[unpackedOffset] = b >> 8;
				unpacked[unpackedOffset + 1] = b & 0xff;
			}
		}
	}
	return this.decodeSt(unpacked, 0, content, contentOffset + 1, mode);
}

FAIL.prototype.decodeTrp = function(content, contentLength) {
	if (contentLength < 9 || !FAIL.isStringAt(content, 0, "TRUP"))
		return false;
	return this.decodeFalconTrueColorVariable(content, contentLength, 4, 8);
}

FAIL.prototype.decodeTru = function(content, contentLength) {
	if (contentLength < 256 || !FAIL.isStringAt(content, 0, "Indy"))
		return false;
	return this.decodeFalconTrueColorVariable(content, contentLength, 4, 256);
}

FAIL.prototype.decodeVzi = function(content, contentLength) {
	if (contentLength != 16000)
		return false;
	this.setSize(320, 200, FAILResolution.XE2X1);
	var frame1 = new Array(64000);
	this.gtiaLeftSkip = -1;
	this.decodeAtari8Gr9(content, 0, 40, frame1, 0, 320, 320, 200);
	this.gtiaLeftSkip = 1;
	var frame2 = new Array(64000);
	this.decodeAtari8Gr9(content, 8000, 40, frame2, 0, 320, 320, 200);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.decodeWnd = function(content, contentLength) {
	if (contentLength != 3072)
		return false;
	var contentStride = (content[0] >> 2) + 1;
	var height = content[1];
	if (contentStride > 40 || height == 0 || height > 192 || contentStride * height > 3070)
		return false;
	this.setSize(contentStride << 3, height, FAILResolution.XE2X1);
	var frame = new Array(61440);
	this.gtiaColors[8] = 0;
	this.gtiaColors[4] = 70;
	this.gtiaColors[5] = 136;
	this.gtiaColors[6] = 14;
	this.decodeAtari8Gr15(content, 2, contentStride, frame, 0, contentStride << 3, height);
	return this.applyAtari8Palette(frame);
}

FAIL.prototype.decodeXlp = function(content, contentLength) {
	var rle = new XlpStream();
	rle.content = content;
	rle.contentLength = contentLength;
	var unpacked = new Array(16000);
	var height;
	var colorsOffset;
	if (contentLength >= 10 && FAIL.isStringAt(content, 0, "XLPC")) {
		Ci.clearArray(unpacked, 0);
		rle.contentOffset = 8;
		rle.unpack(unpacked, 0, 40, 15360);
		height = 192;
		colorsOffset = 4;
	}
	else {
		rle.contentOffset = 4;
		if (rle.unpack(unpacked, 0, 40, 16000))
			height = 200;
		else {
			rle.contentOffset = 4;
			if (rle.unpack(unpacked, 0, 40, 15360))
				height = 192;
			else
				return false;
		}
		colorsOffset = 0;
	}
	this.setSize(320, height, FAILResolution.XE2X1);
	this.setPF012Bak(content, colorsOffset);
	var frame1 = new Array(64000);
	this.decodeAtari8Gr15(unpacked, 0, 40, frame1, 0, 320, height);
	var frame2 = new Array(64000);
	this.decodeAtari8Gr15(unpacked, height * 40, 40, frame2, 0, 320, height);
	return this.applyAtari8PaletteBlend(frame1, frame2);
}

FAIL.prototype.drawBlazingPaddlesVector = function(content, contentLength, frame, frameOffset, index, startAddress) {
	if (index * 2 + 1 >= contentLength)
		return false;
	var contentOffset = content[index * 2] + (content[index * 2 + 1] << 8) - startAddress;
	if (contentOffset < 0)
		return false;
	while (contentOffset < contentLength) {
		var control = content[contentOffset++];
		if (control == 8)
			return true;
		for (; control >= 0; control -= 16) {
			if ((control & 4) == 0)
				frame[frameOffset + 1] = frame[frameOffset] = 14;
			switch (control & 3) {
			case 0:
				frameOffset += 2;
				break;
			case 1:
				frameOffset -= 2;
				break;
			case 2:
				frameOffset -= this.width;
				break;
			case 3:
				frameOffset += this.width;
				break;
			}
		}
	}
	return false;
}

FAIL.drawSpcBrush = function(pixels, x1, y1, brush, pattern) {
	for (var y = 0; y < 16 && y1 + y < 192; y++) {
		var brushShape = FAIL.CI_CONST_ARRAY_3[brush * 16 + y];
		for (var x = 0; x < 8 && x1 + x < 160; x++) {
			if ((brushShape >> 7 - x & 1) != 0)
				FAIL.plotSpcPattern(pixels, x, y, pattern);
		}
	}
}

FAIL.drawSpcChar = function(pixels, x1, y1, ch) {
	if (ch < 32 || ch > 95)
		return;
	var font = FAIL.CI_BINARY_RESOURCE_ATARI8_FNT;
	var fontOffset = ch - 32 << 3;
	for (var y = 0; y < 8 && y1 + y < 192; y++) {
		for (var x = 0; x < 4 && x1 + x < 160; x++)
			pixels[(y1 + y) * 160 + x1 + x] = font[fontOffset + y] >> 6 - x * 2 & 3;
	}
}

FAIL.drawSpcLine = function(pixels, x1, y1, x2, y2, color) {
	var dx = x2 - x1;
	var dy = y2 - y1;
	if (dx < 0)
		dx = -dx;
	if (dy < 0)
		dy = -dy;
	if (dx >= dy) {
		var e = dx;
		if (x2 < x1) {
			var ty = y1;
			x1 = x2;
			x2 += dx;
			y1 = y2;
			y2 = ty;
		}
		for (; x1 <= x2; x1++) {
			if (x1 < 160 && y1 < 192)
				pixels[160 * y1 + x1] = color;
			e -= dy * 2;
			if (e < 0) {
				e += dx * 2;
				y1 += y1 < y2 ? 1 : -1;
			}
		}
	}
	else {
		var e = dy;
		if (y2 < y1) {
			var tx = x1;
			x1 = x2;
			x2 = tx;
			y1 = y2;
			y2 += dy;
		}
		for (; y1 <= y2; y1++) {
			if (x1 < 160 && y1 < 192)
				pixels[160 * y1 + x1] = color;
			e -= dx * 2;
			if (e < 0) {
				e += dy * 2;
				x1 += x1 < x2 ? 1 : -1;
			}
		}
	}
}

FAIL.fillSpc = function(pixels, x, y, pattern) {
	if (x >= 160 || y >= 192)
		return false;
	while (y >= 0 && pixels[y * 160 + x] == 0)
		y--;
	while (++y < 192 && pixels[y * 160 + x] == 0) {
		do
			x--;
		while (x >= 0 && pixels[y * 160 + x] == 0);
		var x1 = x;
		while (x < 159 && pixels[y * 160 + ++x] == 0)
			FAIL.plotSpcPattern(pixels, x, y, pattern);
		x = x1 + (x - x1 + 1 >> 1);
	}
	return true;
}

FAIL.findColor = function(palette, paletteEnd, rgb) {
	var paletteBegin = 0;
	while (paletteBegin < paletteEnd) {
		var index = paletteBegin + paletteEnd >> 1;
		var paletteRgb = palette[index];
		if (rgb == paletteRgb)
			return index;
		if (rgb < paletteRgb)
			paletteEnd = index;
		else
			paletteBegin = index + 1;
	}
	return paletteBegin;
}

FAIL.get32BigEndian = function(content, contentOffset) {
	return content[contentOffset] << 24 | content[contentOffset + 1] << 16 | content[contentOffset + 2] << 8 | content[contentOffset + 3];
}

FAIL.getAtari8ExecutableOffset = function(content, contentLength) {
	if (contentLength >= 7) {
		var blockLength = FAIL.parseAtari8ExecutableHeader(content, 0);
		if (blockLength > 0 && 6 + blockLength == contentLength)
			return 6;
	}
	return 0;
}

FAIL.prototype.getColors = function() {
	if (this.colors == -1) {
		Ci.clearArray(this.palette, 0);
		this.calculatePalette(this.palette, 0, 256);
	}
	if (this.colors == 0) {
		var palette = new Array(this.width * this.height);
		for (var j = 0; j < 256; j++)
			palette[j] = this.palette[j];
		this.calculatePalette(palette, 256, -1);
	}
	return this.colors;
}

FAIL.prototype.getFrames = function() {
	return this.frames;
}

FAIL.prototype.getHeight = function() {
	return this.height;
}

FAIL.prototype.getOriginalHeight = function() {
	switch (this.resolution) {
	case FAILResolution.XE2X2:
	case FAILResolution.XE4X2:
	case FAILResolution.ST1X2:
	case FAILResolution.STE1X2:
		return this.height >> 1;
	default:
		return this.height;
	}
}

FAIL.prototype.getOriginalWidth = function() {
	switch (this.resolution) {
	case FAILResolution.XE2X1:
	case FAILResolution.XE2X2:
		return this.width >> 1;
	case FAILResolution.XE4X1:
	case FAILResolution.XE4X2:
		return this.width >> 2;
	default:
		return this.width;
	}
}

FAIL.getPackedExt = function(filename) {
	var ext = 0;
	for (var i = filename.length; --i > 0;) {
		var c = filename.charCodeAt(i);
		if (c <= 32 || c > 122)
			return 0;
		if (c == 46)
			return ext | 2105376;
		ext = (ext << 8) + c;
	}
	return 0;
}

FAIL.prototype.getPixels = function() {
	return this.pixels;
}

FAIL.prototype.getPlatform = function() {
	switch (this.resolution) {
	case FAILResolution.XE1X1:
	case FAILResolution.XE2X1:
	case FAILResolution.XE4X1:
	case FAILResolution.XE2X2:
	case FAILResolution.XE4X2:
		return "Atari 8-bit";
	case FAILResolution.ST1X1:
	case FAILResolution.ST1X2:
		return "Atari ST";
	case FAILResolution.STE1X1:
	case FAILResolution.STE1X2:
		return "Atari STE";
	case FAILResolution.FALCON1X1:
		return "Atari Falcon";
	case FAILResolution.PORTFOLIO1X1:
		return "Atari Portfolio";
	case FAILResolution.AMIGA1X1:
		return "Amiga";
	default:
		throw "Unknown";
	}
}

FAIL.prototype.getStColor = function(content, contentOffset) {
	var r = content[contentOffset];
	var gb = content[contentOffset + 1];
	var rgb;
	switch (this.resolution) {
	case FAILResolution.STE1X1:
	case FAILResolution.STE1X2:
		rgb = (r & 7) << 17 | (r & 8) << 13 | (gb & 112) << 5 | (gb & 135) << 1 | (gb & 8) >> 3;
		return rgb << 4 | rgb;
	default:
		rgb = (r & 7) << 16 | (gb & 112) << 4 | gb & 7;
		return rgb << 5 | rgb << 2 | rgb >> 1 & 197379;
	}
}

FAIL.prototype.getWidth = function() {
	return this.width;
}

FAIL.isOurFile = function(filename) {
	switch (FAIL.getPackedExt(filename)) {
	case 3552562:
	case 6909236:
	case 7106612:
	case 7172148:
	case 7484513:
	case 7562081:
	case 7366497:
	case 7105633:
	case 3305569:
	case 3371105:
	case 7762017:
	case 7366500:
	case 6517605:
	case 6515817:
	case 7174768:
	case 6516833:
	case 7106657:
	case 7368801:
	case 7631457:
	case 3762018:
	case 3747943:
	case 6777698:
	case 7696994:
	case 3236195:
	case 3301731:
	case 3367267:
	case 6906723:
	case 7497827:
	case 7235939:
	case 7499875:
	case 7630947:
	case 3236708:
	case 7103844:
	case 3237732:
	case 6514532:
	case 7694180:
	case 7235940:
	case 7171172:
	case 7303012:
	case 6844516:
	case 6779492:
	case 7630438:
	case 6517862:
	case 6387558:
	case 6776935:
	case 6582119:
	case 3158375:
	case 3223911:
	case 6448743:
	case 3633767:
	case 3699303:
	case 3764839:
	case 7367016:
	case 7172200:
	case 2126440:
	case 3306088:
	case 6710889:
	case 3239010:
	case 3304546:
	case 3370082:
	case 7234409:
	case 6645609:
	case 7236969:
	case 6778473:
	case 7368297:
	case 7630441:
	case 3305577:
	case 6516841:
	case 3306089:
	case 6779497:
	case 7631721:
	case 7366506:
	case 7889261:
	case 6775405:
	case 6841197:
	case 7365485:
	case 7562093:
	case 7366509:
	case 6515053:
	case 7563629:
	case 7300462:
	case 7433326:
	case 6513008:
	case 3236720:
	case 3302256:
	case 3367792:
	case 7562096:
	case 6514544:
	case 6711152:
	case 3238256:
	case 3303792:
	case 3369328:
	case 3434864:
	case 3762544:
	case 6515056:
	case 6384752:
	case 7171184:
	case 6581616:
	case 7823730:
	case 6449010:
	case 7367026:
	case 3173746:
	case 3239282:
	case 3304818:
	case 3370354:
	case 3435890:
	case 6645619:
	case 6514803:
	case 7366771:
	case 6516851:
	case 7565427:
	case 7696499:
	case 7567475:
	case 7367028:
	case 3239540:
	case 3305076:
	case 3370612:
	case 7958132:
	case 7369332:
	case 7697012:
	case 6912630:
	case 6581879:
	case 7367800:
		return true;
	default:
		return false;
	}
}

FAIL.isStePalette = function(content, contentOffset, colors) {
	while (--colors >= 0) {
		if ((content[contentOffset] & 8) != 0 || (content[contentOffset + 1] & 136) != 0)
			return true;
		contentOffset += 2;
	}
	return false;
}

FAIL.isStringAt = function(content, contentOffset, s) {
	var length = s.length;
	for (var i = 0; i < length; i++)
		if (content[contentOffset + i] != s.charCodeAt(i))
			return false;
	return true;
}
FAIL.MAX_CONTENT_LENGTH = 350000;
FAIL.MAX_HEIGHT = 560;
FAIL.MAX_PIXELS_LENGTH = 358400;
FAIL.MAX_PLATFORM_LENGTH = 15;
FAIL.MAX_WIDTH = 640;

FAIL.parseAtari8ExecutableHeader = function(content, contentOffset) {
	if (content[contentOffset] != 255 || content[contentOffset + 1] != 255)
		return -1;
	var startAddress = content[contentOffset + 2] | content[contentOffset + 3] << 8;
	var endAddress = content[contentOffset + 4] | content[contentOffset + 5] << 8;
	return endAddress - startAddress + 1;
}

FAIL.plotSpcPattern = function(pixels, x, y, pattern) {
	pixels[y * 160 + x] = pattern >> (~y & 1) * 8 + (~x & 3) * 2 & 3;
}

FAIL.prototype.setAtari8Palette = function(content) {
	if (content == null)
		content = FAIL.CI_BINARY_RESOURCE_JAKUB_ACT;
	for (var i = 0; i < 256; i++)
		this.atari8Palette[i] = content[i * 3] << 16 | content[i * 3 + 1] << 8 | content[i * 3 + 2];
}

FAIL.prototype.setAtari8RawSize = function(content, contentLength, resolution) {
	var contentOffset = FAIL.getAtari8ExecutableOffset(content, contentLength);
	var height = Math.floor((contentLength - contentOffset) / 40);
	if (height == 0 || height > 240)
		return false;
	this.setSize(320, height, resolution);
	return true;
}

FAIL.prototype.setBakPF012 = function(content, contentOffset, contentStride) {
	for (var i = 0; i < 4; i++)
		this.gtiaColors[i == 0 ? 8 : 3 + i] = content[contentOffset + i * contentStride] & 254;
}

FAIL.prototype.setBakPF0123 = function(content, contentOffset) {
	for (var i = 0; i < 5; i++)
		this.gtiaColors[i == 0 ? 8 : 3 + i] = content[contentOffset + i] & 254;
}

FAIL.prototype.setFalconPalette = function(content, contentOffset) {
	for (var i = 0; i < 256; i++) {
		var offset = contentOffset + (i << 2);
		this.atari16Palette[i] = content[offset] << 16 | content[offset + 1] << 8 | content[offset + 3];
	}
}

FAIL.prototype.setGr15DefaultColors = function() {
	this.gtiaColors[8] = 0;
	this.gtiaColors[4] = 4;
	this.gtiaColors[5] = 8;
	this.gtiaColors[6] = 12;
}

FAIL.prototype.setGtiaColor = function(reg, value) {
	value &= 254;
	switch (reg) {
	case 0:
	case 1:
	case 2:
	case 3:
		this.gtiaColors[reg] = value;
		break;
	case 4:
	case 5:
	case 6:
	case 7:
		this.gtiaColors[8 + reg] = this.gtiaColors[reg] = value;
		break;
	case 8:
		this.gtiaColors[11] = this.gtiaColors[10] = this.gtiaColors[9] = this.gtiaColors[8] = value;
		break;
	}
}

FAIL.prototype.setGtiaColors = function(content, contentOffset) {
	this.gtiaColors[0] = content[contentOffset] & 254;
	this.setPM123PF0123Bak(content, contentOffset + 1);
}

FAIL.prototype.setPF0123Bak = function(content, contentOffset) {
	for (var i = 0; i < 5; i++)
		this.gtiaColors[4 + i] = content[contentOffset + i] & 254;
}

FAIL.prototype.setPF0123Even = function(content, contentOffset) {
	for (var i = 0; i < 4; i++)
		this.gtiaColors[4 + i] = content[contentOffset + i * 2] & 254;
}

FAIL.prototype.setPF012Bak = function(content, contentOffset) {
	for (var i = 0; i < 4; i++)
		this.gtiaColors[i == 3 ? 8 : 4 + i] = content[contentOffset + i] & 254;
}

FAIL.prototype.setPF21 = function(content, contentOffset) {
	this.gtiaColors[6] = content[contentOffset] & 254;
	this.gtiaColors[5] = content[contentOffset + 1] & 254;
}

FAIL.prototype.setPM123PF0123Bak = function(content, contentOffset) {
	for (var i = 0; i < 8; i++)
		this.setGtiaColor(1 + i, content[contentOffset + i]);
}

FAIL.prototype.setSize = function(width, height, resolution) {
	this.width = width;
	this.height = height;
	this.resolution = resolution;
	this.frames = 1;
	this.colors = -1;
	this.gtiaLeftSkip = 0;
}

FAIL.prototype.setSizeStOrFalcon = function(width, height, bitplanes) {
	this.setSize(width, height, bitplanes == 1 && width <= 640 && height <= 400 || bitplanes <= 4 && width <= 320 && height <= 200 ? FAILResolution.ST1X1 : FAILResolution.FALCON1X1);
}

FAIL.prototype.setStPalette = function(content, contentOffset, colors) {
	for (var c = 0; c < colors; c++)
		this.atari16Palette[c] = this.getStColor(content, contentOffset + c * 2);
}

FAIL.toAtari8Char = function(ascii) {
	switch (ascii & 96) {
	case 0:
		return ascii + 64;
	case 32:
	case 64:
		return ascii - 32;
	default:
		return ascii;
	}
}

FAIL.prototype.toPalette = function(indexes) {
	if (this.colors == -1) {
		Ci.clearArray(this.palette, 0);
		this.calculatePalette(this.palette, 0, 256);
	}
	if (this.colors == 0 || this.colors > 256)
		return null;
	var pixelsCount = this.width * this.height;
	for (var i = 0; i < pixelsCount; i++)
		indexes[i] = FAIL.findColor(this.palette, this.colors, this.pixels[i]);
	return this.palette;
}

FAIL.prototype.unpackRip = function(content, contentOffset, contentLength, unpacked, unpackedLength) {
	if (contentOffset + 304 > contentLength || !FAIL.isStringAt(content, contentOffset, "PCK"))
		return false;
	var lengthTree = new FanoTree();
	lengthTree.create(content, contentOffset + 16, 64);
	var distanceTree = new FanoTree();
	distanceTree.create(content, contentOffset + 16 + 32, 256);
	var literalTree = new FanoTree();
	literalTree.create(content, contentOffset + 16 + 32 + 128, 256);
	var bitStream = new BitStream();
	bitStream.content = content;
	bitStream.contentOffset = contentOffset + 16 + 288;
	bitStream.contentLength = contentLength;
	for (var unpackedOffset = 0; unpackedOffset < unpackedLength;) {
		switch (bitStream.readBit()) {
		case -1:
			return false;
		case 0:
			var literal = literalTree.readCode(bitStream);
			if (literal < 0)
				return false;
			unpacked[unpackedOffset++] = literal;
			break;
		case 1:
			var distance = distanceTree.readCode(bitStream);
			if (distance < 0)
				return false;
			distance += 2;
			if (distance > unpackedOffset)
				return false;
			var length = lengthTree.readCode(bitStream);
			if (length < 0)
				return false;
			length += 2;
			do {
				unpacked[unpackedOffset] = unpacked[unpackedOffset - distance];
				if (++unpackedOffset >= unpackedLength)
					return true;
			}
			while (--length > 0);
			break;
		}
	}
	return true;
}

FAIL.unpackSpc = function(rle, unpacked) {
	for (var bitplane = 0; bitplane < 8; bitplane += 2) {
		for (var unpackedOffset = 160 + bitplane; unpackedOffset < 32000; unpackedOffset += 8) {
			for (var x = 0; x < 2; x++) {
				var b = rle.readRle();
				if (b < 0)
					return false;
				unpacked[unpackedOffset + x] = b;
			}
		}
	}
	return true;
}
FAIL.VERSION = "2.0.1";
FAIL.VERSION_MAJOR = 2;
FAIL.VERSION_MICRO = 1;
FAIL.VERSION_MINOR = 0;
FAIL.YEARS = "2009-2013";
FAIL.CI_CONST_ARRAY_1 = [ 0, 0, 2, 4, 6, 8, 10, 12, 14 ];
FAIL.CI_CONST_ARRAY_2 = [ 0, 2, 4, 6, 8, 10, 12, 14, 0 ];
FAIL.CI_CONST_ARRAY_3 = [ 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 48, 48, 48, 48, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 16, 56, 56, 56, 56, 16, 0, 0, 0, 0, 0, 0,
	0, 0, 16, 56, 56, 124, 124, 124, 124, 56, 56, 16, 0, 0, 0, 0,
	0, 24, 24, 60, 60, 126, 126, 126, 126, 60, 60, 24, 24, 0, 0, 0,
	16, 56, 124, 124, 124, 254, 254, 254, 254, 124, 124, 124, 56, 16, 0, 0,
	0, 0, 16, 40, 40, 80, 60, 120, 20, 40, 40, 16, 0, 0, 0, 0,
	16, 40, 84, 40, 84, 186, 124, 124, 186, 84, 40, 84, 40, 16, 0, 0 ];
FAIL.CI_CONST_ARRAY_4 = [ 0, 21845, 43690, 65535, 4420, 8840, 13260, 26265, 30685, 48110, 5457, 10914, 16371, 16388, 27302, 32759,
	32776, 38233, 49147, 49164, 54621, 60078, 21896, 8908, 13124, 17561, 17629, 30617, 35054, 34918, 39406, 52343,
	52411, 56763, 7089, 5465, 5469, 38237, 16392, 16396, 32780, 27308, 10926, 27298, 32763, 16379, 49143, 21892,
	8900, 13128, 17553, 17617, 30609, 35042, 34914, 39393, 52339, 52403, 56755, 21900, 8904, 13132, 17565, 17625,
	30621, 35046, 34926, 39397, 52347, 52407, 56759 ];
FAIL.CI_CONST_ARRAY_5 = [ 0, 21, 149, 54 ];
FAIL.CI_BINARY_RESOURCE_ATARI8_FNT = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 24, 24, 0, 24, 0,
	0, 102, 102, 102, 0, 0, 0, 0, 0, 102, 255, 102, 102, 255, 102, 0,
	24, 62, 96, 60, 6, 124, 24, 0, 0, 102, 108, 24, 48, 102, 70, 0,
	28, 54, 28, 56, 111, 102, 59, 0, 0, 24, 24, 24, 0, 0, 0, 0,
	0, 14, 28, 24, 24, 28, 14, 0, 0, 112, 56, 24, 24, 56, 112, 0,
	0, 102, 60, 255, 60, 102, 0, 0, 0, 24, 24, 126, 24, 24, 0, 0,
	0, 0, 0, 0, 0, 24, 24, 48, 0, 0, 0, 126, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 24, 24, 0, 0, 6, 12, 24, 48, 96, 64, 0,
	0, 60, 102, 110, 118, 102, 60, 0, 0, 24, 56, 24, 24, 24, 126, 0,
	0, 60, 102, 12, 24, 48, 126, 0, 0, 126, 12, 24, 12, 102, 60, 0,
	0, 12, 28, 60, 108, 126, 12, 0, 0, 126, 96, 124, 6, 102, 60, 0,
	0, 60, 96, 124, 102, 102, 60, 0, 0, 126, 6, 12, 24, 48, 48, 0,
	0, 60, 102, 60, 102, 102, 60, 0, 0, 60, 102, 62, 6, 12, 56, 0,
	0, 0, 24, 24, 0, 24, 24, 0, 0, 0, 24, 24, 0, 24, 24, 48,
	6, 12, 24, 48, 24, 12, 6, 0, 0, 0, 126, 0, 0, 126, 0, 0,
	96, 48, 24, 12, 24, 48, 96, 0, 0, 60, 102, 12, 24, 0, 24, 0,
	0, 60, 102, 110, 110, 96, 62, 0, 0, 24, 60, 102, 102, 126, 102, 0,
	0, 124, 102, 124, 102, 102, 124, 0, 0, 60, 102, 96, 96, 102, 60, 0,
	0, 120, 108, 102, 102, 108, 120, 0, 0, 126, 96, 124, 96, 96, 126, 0,
	0, 126, 96, 124, 96, 96, 96, 0, 0, 62, 96, 96, 110, 102, 62, 0,
	0, 102, 102, 126, 102, 102, 102, 0, 0, 126, 24, 24, 24, 24, 126, 0,
	0, 6, 6, 6, 6, 102, 60, 0, 0, 102, 108, 120, 120, 108, 102, 0,
	0, 96, 96, 96, 96, 96, 126, 0, 0, 99, 119, 127, 107, 99, 99, 0,
	0, 102, 118, 126, 126, 110, 102, 0, 0, 60, 102, 102, 102, 102, 60, 0,
	0, 124, 102, 102, 124, 96, 96, 0, 0, 60, 102, 102, 102, 108, 54, 0,
	0, 124, 102, 102, 124, 108, 102, 0, 0, 60, 96, 60, 6, 6, 60, 0,
	0, 126, 24, 24, 24, 24, 24, 0, 0, 102, 102, 102, 102, 102, 126, 0,
	0, 102, 102, 102, 102, 60, 24, 0, 0, 99, 99, 107, 127, 119, 99, 0,
	0, 102, 102, 60, 60, 102, 102, 0, 0, 102, 102, 60, 24, 24, 24, 0,
	0, 126, 12, 24, 48, 96, 126, 0, 0, 30, 24, 24, 24, 24, 30, 0,
	0, 64, 96, 48, 24, 12, 6, 0, 0, 120, 24, 24, 24, 24, 120, 0,
	0, 8, 28, 54, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 0,
	0, 54, 127, 127, 62, 28, 8, 0, 24, 24, 24, 31, 31, 24, 24, 24,
	3, 3, 3, 3, 3, 3, 3, 3, 24, 24, 24, 248, 248, 0, 0, 0,
	24, 24, 24, 248, 248, 24, 24, 24, 0, 0, 0, 248, 248, 24, 24, 24,
	3, 7, 14, 28, 56, 112, 224, 192, 192, 224, 112, 56, 28, 14, 7, 3,
	1, 3, 7, 15, 31, 63, 127, 255, 0, 0, 0, 0, 15, 15, 15, 15,
	128, 192, 224, 240, 248, 252, 254, 255, 15, 15, 15, 15, 0, 0, 0, 0,
	240, 240, 240, 240, 0, 0, 0, 0, 255, 255, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 255, 255, 0, 0, 0, 0, 240, 240, 240, 240,
	0, 28, 28, 119, 119, 8, 28, 0, 0, 0, 0, 31, 31, 24, 24, 24,
	0, 0, 0, 255, 255, 0, 0, 0, 24, 24, 24, 255, 255, 24, 24, 24,
	0, 0, 60, 126, 126, 126, 60, 0, 0, 0, 0, 0, 255, 255, 255, 255,
	192, 192, 192, 192, 192, 192, 192, 192, 0, 0, 0, 255, 255, 24, 24, 24,
	24, 24, 24, 255, 255, 0, 0, 0, 240, 240, 240, 240, 240, 240, 240, 240,
	24, 24, 24, 31, 31, 0, 0, 0, 120, 96, 120, 96, 126, 24, 30, 0,
	0, 24, 60, 126, 24, 24, 24, 0, 0, 24, 24, 24, 126, 60, 24, 0,
	0, 24, 48, 126, 48, 24, 0, 0, 0, 24, 12, 126, 12, 24, 0, 0,
	0, 24, 60, 126, 126, 60, 24, 0, 0, 0, 60, 6, 62, 102, 62, 0,
	0, 96, 96, 124, 102, 102, 124, 0, 0, 0, 60, 96, 96, 96, 60, 0,
	0, 6, 6, 62, 102, 102, 62, 0, 0, 0, 60, 102, 126, 96, 60, 0,
	0, 14, 24, 62, 24, 24, 24, 0, 0, 0, 62, 102, 102, 62, 6, 124,
	0, 96, 96, 124, 102, 102, 102, 0, 0, 24, 0, 56, 24, 24, 60, 0,
	0, 6, 0, 6, 6, 6, 6, 60, 0, 96, 96, 108, 120, 108, 102, 0,
	0, 56, 24, 24, 24, 24, 60, 0, 0, 0, 102, 127, 127, 107, 99, 0,
	0, 0, 124, 102, 102, 102, 102, 0, 0, 0, 60, 102, 102, 102, 60, 0,
	0, 0, 124, 102, 102, 124, 96, 96, 0, 0, 62, 102, 102, 62, 6, 6,
	0, 0, 124, 102, 96, 96, 96, 0, 0, 0, 62, 96, 60, 6, 124, 0,
	0, 24, 126, 24, 24, 24, 14, 0, 0, 0, 102, 102, 102, 102, 62, 0,
	0, 0, 102, 102, 102, 60, 24, 0, 0, 0, 99, 107, 127, 62, 54, 0,
	0, 0, 102, 60, 24, 60, 102, 0, 0, 0, 102, 102, 102, 62, 12, 120,
	0, 0, 126, 12, 24, 48, 126, 0, 0, 24, 60, 126, 126, 24, 60, 0,
	24, 24, 24, 24, 24, 24, 24, 24, 0, 126, 120, 124, 110, 102, 6, 0,
	8, 24, 56, 120, 56, 24, 8, 0, 16, 24, 28, 30, 28, 24, 16, 0 ];
FAIL.CI_BINARY_RESOURCE_JAKUB_ACT = [ 45, 45, 45, 59, 59, 59, 73, 73, 73, 87, 87, 87, 101, 101, 101, 115,
	115, 115, 129, 129, 129, 143, 143, 143, 157, 157, 157, 171, 171, 171, 185, 185,
	185, 199, 199, 199, 213, 213, 213, 227, 227, 227, 241, 241, 241, 255, 255, 255,
	92, 35, 0, 106, 49, 0, 120, 63, 0, 134, 77, 10, 148, 91, 24, 162,
	105, 38, 176, 119, 52, 190, 133, 66, 204, 147, 80, 218, 161, 94, 232, 175,
	108, 246, 189, 122, 255, 203, 136, 255, 217, 150, 255, 231, 164, 255, 245, 178,
	105, 20, 9, 119, 34, 23, 133, 48, 37, 147, 62, 51, 161, 76, 65, 175,
	90, 79, 189, 104, 93, 203, 118, 107, 217, 132, 121, 231, 146, 135, 245, 160,
	149, 255, 174, 163, 255, 188, 177, 255, 202, 191, 255, 216, 205, 255, 230, 219,
	108, 10, 56, 122, 24, 70, 136, 38, 84, 150, 52, 98, 164, 66, 112, 178,
	80, 126, 192, 94, 140, 206, 108, 154, 220, 122, 168, 234, 136, 182, 248, 150,
	196, 255, 164, 210, 255, 178, 224, 255, 192, 238, 255, 206, 252, 255, 220, 255,
	100, 5, 101, 114, 19, 115, 128, 33, 129, 142, 47, 143, 156, 61, 157, 170,
	75, 171, 184, 89, 185, 198, 103, 199, 212, 117, 213, 226, 131, 227, 240, 145,
	241, 254, 159, 255, 255, 173, 255, 255, 187, 255, 255, 201, 255, 255, 215, 255,
	82, 7, 137, 96, 21, 151, 110, 35, 165, 124, 49, 179, 138, 63, 193, 152,
	77, 207, 166, 91, 221, 180, 105, 235, 194, 119, 249, 208, 133, 255, 222, 147,
	255, 236, 161, 255, 250, 175, 255, 255, 189, 255, 255, 203, 255, 255, 217, 255,
	58, 16, 156, 72, 30, 170, 86, 44, 184, 100, 58, 198, 114, 72, 212, 128,
	86, 226, 142, 100, 240, 156, 114, 254, 170, 128, 255, 184, 142, 255, 198, 156,
	255, 212, 170, 255, 226, 184, 255, 240, 198, 255, 254, 212, 255, 255, 226, 255,
	31, 30, 156, 45, 44, 170, 59, 58, 184, 73, 72, 198, 87, 86, 212, 101,
	100, 226, 115, 114, 240, 129, 128, 254, 143, 142, 255, 157, 156, 255, 171, 170,
	255, 185, 184, 255, 199, 198, 255, 213, 212, 255, 227, 226, 255, 241, 240, 255,
	7, 46, 137, 21, 60, 151, 35, 74, 165, 49, 88, 179, 63, 102, 193, 77,
	116, 207, 91, 130, 221, 105, 144, 235, 119, 158, 249, 133, 172, 255, 147, 186,
	255, 161, 200, 255, 175, 214, 255, 189, 228, 255, 203, 242, 255, 217, 255, 255,
	0, 62, 101, 3, 76, 115, 17, 90, 129, 31, 104, 143, 45, 118, 157, 59,
	132, 171, 73, 146, 185, 87, 160, 199, 101, 174, 213, 115, 188, 227, 129, 202,
	241, 143, 216, 255, 157, 230, 255, 171, 244, 255, 185, 255, 255, 199, 255, 255,
	0, 75, 56, 0, 89, 70, 9, 103, 84, 23, 117, 98, 37, 131, 112, 51,
	145, 126, 65, 159, 140, 79, 173, 154, 93, 187, 168, 107, 201, 182, 121, 215,
	196, 135, 229, 210, 149, 243, 224, 163, 255, 238, 177, 255, 252, 191, 255, 255,
	0, 82, 9, 0, 96, 23, 12, 110, 37, 26, 124, 51, 40, 138, 65, 54,
	152, 79, 68, 166, 93, 82, 180, 107, 96, 194, 121, 110, 208, 135, 124, 222,
	149, 138, 236, 163, 152, 250, 177, 166, 255, 191, 180, 255, 205, 194, 255, 219,
	0, 83, 0, 11, 97, 0, 25, 111, 0, 39, 125, 10, 53, 139, 24, 67,
	153, 38, 81, 167, 52, 95, 181, 66, 109, 195, 80, 123, 209, 94, 137, 223,
	108, 151, 237, 122, 165, 251, 136, 179, 255, 150, 193, 255, 164, 207, 255, 178,
	19, 78, 0, 33, 92, 0, 47, 106, 0, 61, 120, 0, 75, 134, 0, 89,
	148, 11, 103, 162, 25, 117, 176, 39, 131, 190, 53, 145, 204, 67, 159, 218,
	81, 173, 232, 95, 187, 246, 109, 201, 255, 123, 215, 255, 137, 229, 255, 151,
	45, 67, 0, 59, 81, 0, 73, 95, 0, 87, 109, 0, 101, 123, 0, 115,
	137, 1, 129, 151, 15, 143, 165, 29, 157, 179, 43, 171, 193, 57, 185, 207,
	71, 199, 221, 85, 213, 235, 99, 227, 249, 113, 241, 255, 127, 255, 255, 141,
	70, 51, 0, 84, 65, 0, 98, 79, 0, 112, 93, 0, 126, 107, 0, 140,
	121, 11, 154, 135, 25, 168, 149, 39, 182, 163, 53, 196, 177, 67, 210, 191,
	81, 224, 205, 95, 238, 219, 109, 252, 233, 123, 255, 247, 137, 255, 255, 151 ];

var FAILResolution = {
	XE1X1 : 0,
	XE2X1 : 1,
	XE4X1 : 2,
	XE2X2 : 3,
	XE4X2 : 4,
	ST1X1 : 5,
	ST1X2 : 6,
	STE1X1 : 7,
	STE1X2 : 8,
	FALCON1X1 : 9,
	PORTFOLIO1X1 : 10,
	AMIGA1X1 : 11
}

function FanoTree()
{
	this.count = new Array(16);
	this.values = new Array(256);
}

FanoTree.prototype.create = function(content, contentOffset, codeCount) {
	Ci.clearArray(this.count, 0);
	for (var code = 0; code < codeCount; code++) {
		var bits = content[contentOffset + (code >> 1)];
		bits = (code & 1) == 0 ? bits >> 4 : bits & 15;
		this.count[bits]++;
	}
	var positions = new Array(16);
	var position = 0;
	for (var bits = 0; bits < 16; bits++) {
		positions[bits] = position;
		position += this.count[bits];
	}
	for (var code = 0; code < codeCount; code++) {
		var bits = content[contentOffset + (code >> 1)];
		bits = (code & 1) == 0 ? bits >> 4 : bits & 15;
		this.values[positions[bits]++] = code;
	}
}

FanoTree.prototype.readCode = function(bitStream) {
	var code = 0;
	var valuesOffset = this.count[0];
	for (var bits = 1; bits < 16; bits++) {
		var bit = bitStream.readBit();
		if (bit < 0)
			return -1;
		code = code << 1 | bit;
		var count = this.count[bits];
		if (code < count)
			return this.values[valuesOffset + code];
		code -= count;
		valuesOffset += count;
	}
	return -1;
}

function HpmStream()
{
}
HpmStream.prototype = new RleStream();

HpmStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b == 0) {
		this.repeatValue = this.readByte();
		this.repeatCount = this.readByte();
	}
	else {
		this.repeatCount = b;
		this.repeatValue = -1;
	}
	return true;
}

function IcnParser()
{
	this.content = null;
	this.contentLength = 0;
	this.contentOffset = 0;
}

IcnParser.prototype.expect = function(s) {
	if (!this.skipWhitespace())
		return false;
	var length = s.length;
	for (var i = 0; i < length; i++)
		if (this.content[this.contentOffset++] != s.charCodeAt(i))
			return false;
	return true;
}

IcnParser.prototype.parseDefine = function(s) {
	if (!this.expect("#define") || !this.expect(s))
		return -1;
	return this.parseHex();
}

IcnParser.prototype.parseHex = function() {
	if (!this.expect("0x"))
		return -1;
	var r = 0;
	for (; this.contentOffset < this.contentLength; this.contentOffset++) {
		var c = this.content[this.contentOffset];
		if (c >= 48 && c <= 57)
			c -= 48;
		else if (c >= 65 && c <= 70)
			c -= 55;
		else if (c >= 97 && c <= 102)
			c -= 87;
		else
			return r;
		if (r >> 12 != 0)
			return -1;
		r = r << 4 | c;
	}
	return r;
}

IcnParser.prototype.skipWhitespace = function() {
	var got = false;
	while (this.contentOffset < this.contentLength) {
		switch (this.content[this.contentOffset]) {
		case 32:
		case 9:
		case 13:
		case 10:
			this.contentOffset++;
			got = true;
			break;
		case 47:
			if (this.contentOffset + 3 >= this.contentLength || this.content[this.contentOffset + 1] != 42)
				return false;
			this.contentOffset += 3;
			do {
				if (++this.contentOffset > this.contentLength)
					return false;
			}
			while (this.content[this.contentOffset - 2] != 42 || this.content[this.contentOffset - 1] != 47);
			got = true;
			break;
		default:
			return got;
		}
	}
	return true;
}

function KoalaStream()
{
}
KoalaStream.prototype = new RleStream();

KoalaStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	var rle;
	if (b < 128)
		rle = true;
	else {
		b -= 128;
		rle = false;
	}
	if (b == 0) {
		var hi = this.readByte();
		if (hi < 0)
			return false;
		b = this.readByte();
		if (b < 0)
			return false;
		b |= hi << 8;
	}
	this.repeatCount = b;
	this.repeatValue = rle ? this.readByte() : -1;
	return true;
}

KoalaStream.unpackKoala = function(type, content, contentOffset, contentLength, unpacked, unpackedLength) {
	var rle = new KoalaStream();
	rle.content = content;
	rle.contentOffset = contentOffset;
	rle.contentLength = contentLength;
	switch (type) {
	case 0:
		if (contentLength - contentOffset != unpackedLength)
			return false;
		Ci.copyArray(content, contentOffset, unpacked, 0, unpackedLength);
		return true;
	case 1:
		for (var x = 0; x < 40; x++) {
			for (var offset = x; offset < 80; offset += 40) {
				for (var unpackedOffset = offset; unpackedOffset < unpackedLength; unpackedOffset += 80) {
					var b = rle.readRle();
					if (b < 0)
						return false;
					unpacked[unpackedOffset] = b;
				}
			}
		}
		return true;
	case 2:
		return rle.unpack(unpacked, 0, 1, unpackedLength);
	default:
		return false;
	}
}

KoalaStream.unpackKoalaWrapped = function(content, contentLength, unpacked, unpackedLength) {
	return contentLength >= 26 && content[0] == 255 && content[1] == 128 && content[2] == 201 && content[3] == 199 && content[4] >= 26 && content[4] < contentLength && content[5] == 0 && content[6] == 1 && content[8] == 14 && content[9] == 0 && content[10] == 40 && content[11] == 0 && content[12] == 192 && content[20] == 0 && content[21] == 0 && KoalaStream.unpackKoala(content[7], content, content[4] + 1, contentLength, unpacked, unpackedLength);
}

function PacStream()
{
}
PacStream.prototype = new RleStream();

PacStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b == this.content[4]) {
		b = this.readByte();
		if (b < 0)
			return false;
		this.repeatCount = b + 1;
		this.repeatValue = this.content[5];
	}
	else if (b == this.content[6]) {
		this.repeatValue = this.readByte();
		if (this.repeatValue < 0)
			return false;
		b = this.readByte();
		if (b < 0)
			return false;
		this.repeatCount = b + 1;
	}
	else {
		this.repeatCount = 1;
		this.repeatValue = b;
	}
	return true;
}

function PackBitsStream()
{
}
PackBitsStream.prototype = new RleStream();

PackBitsStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		this.repeatCount = b + 1;
		this.repeatValue = -1;
	}
	else if (b > 128) {
		this.repeatCount = 257 - b;
		this.repeatValue = this.readByte();
	}
	else
		this.repeatCount = 0;
	return true;
}

function TnyPcsStream()
{
}
TnyPcsStream.prototype = new RleStream();

TnyPcsStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		if (b == 0 || b == 1) {
			if (this.contentOffset + 1 >= this.contentLength)
				return false;
			this.repeatCount = this.content[this.contentOffset] << 8 | this.content[this.contentOffset + 1];
			this.contentOffset += 2;
		}
		else
			this.repeatCount = b;
		this.repeatValue = b == 1 ? -1 : this.readValue();
	}
	else {
		this.repeatCount = 256 - b;
		this.repeatValue = -1;
	}
	return true;
}

function PcsStream()
{
	this.palette = false;
}
PcsStream.prototype = new TnyPcsStream();

PcsStream.prototype.readValue = function() {
	if (!this.palette)
		return this.readByte();
	if (this.contentOffset + 1 >= this.contentLength)
		return -1;
	var value = this.content[this.contentOffset] << 8 | this.content[this.contentOffset + 1];
	this.contentOffset += 2;
	return value;
}

PcsStream.prototype.unpackPcs = function(unpacked) {
	this.contentOffset += 2;
	this.palette = false;
	for (var unpackedOffset = 0; unpackedOffset < 32000; unpackedOffset++) {
		var b = this.readRle();
		if (b < 0)
			return false;
		unpacked[unpackedOffset] = b;
	}
	if (this.repeatCount != 0)
		return false;
	this.contentOffset += 2;
	this.palette = true;
	for (var unpackedOffset = 32000; unpackedOffset < 51232; unpackedOffset += 2) {
		var b = this.readRle();
		if (b < 0)
			return false;
		unpacked[unpackedOffset] = b >> 8;
		unpacked[unpackedOffset + 1] = b & 0xff;
	}
	return true;
}

function PgcStream()
{
}
PgcStream.prototype = new RleStream();

PgcStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		this.repeatCount = b;
		this.repeatValue = -1;
	}
	else {
		this.repeatCount = b - 128;
		this.repeatValue = this.readByte();
	}
	return true;
}

function RgbStream()
{
}
RgbStream.prototype = new RleStream();

RgbStream.prototype.readCommand = function() {
	var b = this.readBits(4);
	if (b < 0)
		return false;
	var rle;
	if (b < 8)
		rle = true;
	else {
		b -= 8;
		rle = false;
	}
	if (b == 0) {
		b = this.readBits(4);
		if (b < 0)
			return false;
		b += 7;
	}
	if (rle) {
		this.repeatValue = this.readValue();
		b++;
	}
	else
		this.repeatValue = -1;
	this.repeatCount = b;
	return true;
}

RgbStream.prototype.readValue = function() {
	return this.readBits(12);
}

function SpcStream()
{
}
SpcStream.prototype = new RleStream();

SpcStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		this.repeatCount = b + 1;
		this.repeatValue = -1;
	}
	else {
		this.repeatCount = 258 - b;
		this.repeatValue = this.readByte();
	}
	return true;
}

function SpsStream()
{
}
SpsStream.prototype = new RleStream();

SpsStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		this.repeatCount = b + 3;
		this.repeatValue = this.readByte();
	}
	else {
		this.repeatCount = b - 127;
		this.repeatValue = -1;
	}
	return true;
}

function TnyStream()
{
	this.valueLength = 0;
	this.valueOffset = 0;
}
TnyStream.prototype = new TnyPcsStream();

TnyStream.prototype.readValue = function() {
	if (this.valueOffset + 1 >= this.valueLength)
		return -1;
	var value = this.content[this.valueOffset] << 8 | this.content[this.valueOffset + 1];
	this.valueOffset += 2;
	return value;
}

function VdatStream()
{
}
VdatStream.prototype = new TnyStream();

VdatStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	if (b < 128) {
		if (b == 0 || b == 1) {
			this.repeatCount = this.readValue();
			if (this.repeatCount < 0)
				return false;
		}
		else
			this.repeatCount = b;
		this.repeatValue = b == 0 ? -1 : this.readValue();
	}
	else {
		this.repeatCount = 256 - b;
		this.repeatValue = -1;
	}
	return true;
}

function XlpStream()
{
}
XlpStream.prototype = new RleStream();

XlpStream.prototype.readCommand = function() {
	var b = this.readByte();
	if (b < 0)
		return false;
	var rle;
	if (b < 128)
		rle = false;
	else {
		b -= 128;
		rle = true;
	}
	this.repeatCount = b;
	if (b >= 64) {
		b = this.readByte();
		if (b < 0)
			return false;
		this.repeatCount = this.repeatCount - 64 << 8 | b;
	}
	this.repeatValue = rle ? this.readByte() : -1;
	return true;
}
var Ci = {
	copyArray : function(sa, soffset, da, doffset, length) {
		for (var i = 0; i < length; i++)
			da[doffset + i] = sa[soffset + i];
	},
	clearArray : function(a, value) {
		for (var i = 0; i < a.length; i++)
			a[i] = value;
	}
};
